#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <gtk/gtk.h>
#include <gdk/gdkx.h>
#include <signal.h>
#include <sys/wait.h>
#ifdef ENABLE_NLS
#  include <libintl.h>
#  undef _
#  define _(String) dgettext (PACKAGE, String)
#  ifdef gettext_noop
#    define N_(String) gettext_noop (String)
#  else
#    define N_(String) (String)
#  endif
#else
#  define textdomain(String) (String)
#  define gettext(String) (String)
#  define dgettext(Domain,Message) (Message)
#  define dcgettext(Domain,Message,Type) (Message)
#  define bindtextdomain(Domain,Directory) (Domain)
#  define _(String) (String)
#  define N_(String) (String)
#endif
#include "admin.p.h"

GtkWidget *create_admin (void);
GtkWidget *create_pass (void);
GtkWidget *create_user (void);
GtkWidget *create_group (void);
GtkWidget *create_module_access (void);
GtkWidget *create_address_access (void);
GtkWidget *create_groupdel (void);
void message (gchar *text);
void update_admin_widget(GtkWidget *top);

GtkWidget *base = NULL;

gboolean
on_groupdel_delete_event         (GtkWidget       *widget,
				  GdkEvent        *event,
				  gpointer         user_data);
void
on_groupdel_del_clicked                (GtkButton       *button,
					gpointer         user_data);
void
on_groupdel_cancel_clicked             (GtkButton       *button,
					gpointer         user_data);
gboolean
on_admin_delete_event                  (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data);
void
on_groups_select_row                    (GtkCList        *clist,
					 gint             row,
					 gint             column,
					 GdkEvent        *event,
					 gpointer         user_data);
void
on_groups_unselect_row                    (GtkCList        *clist,
					   gint             row,
					   gint             column,
					   GdkEvent        *event,
					   gpointer         user_data);
void
on_users_select_row                    (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);
void
on_add_user_clicked                    (GtkButton       *button,
                                        gpointer         user_data);
void
on_del_user_clicked                    (GtkButton       *button,
                                        gpointer         user_data);
void
on_pass_user_clicked                   (GtkButton       *button,
					gpointer         user_data);
void
on_group_add_clicked                   (GtkButton       *button,
					gpointer         user_data);
void
on_group_del_clicked                   (GtkButton       *button,
					gpointer         user_data);
void
on_module_add_clicked                  (GtkButton       *button,
					gpointer         user_data);
void
on_module_del_clicked                  (GtkButton       *button,
					gpointer         user_data);
void
on_address_add_clicked                 (GtkButton       *button,
					gpointer         user_data);
void
on_address_del_clicked                 (GtkButton       *button,
					gpointer         user_data);
void
on_close_clicked                       (GtkButton       *button,
					gpointer         user_data);
gboolean
on_pass_delete_event                   (GtkWidget       *widget,
					GdkEvent        *event,
					gpointer         user_data);
void
on_pass_ok_clicked                  (GtkButton       *button,
				     gpointer         user_data);
void
on_group_ok_clicked                  (GtkButton       *button,
				      gpointer         user_data);
gboolean
on_user_delete_event                   (GtkWidget       *widget,
					GdkEvent        *event,
					gpointer         user_data);
void
on_user_close_clicked                  (GtkButton       *button,
					gpointer         user_data);
gboolean
on_message_delete_event                (GtkWidget       *widget,
					GdkEvent        *event,
					gpointer         user_data);
void
on_message_ok_clicked                  (GtkButton       *button,
					gpointer         user_data);
gboolean
on_module_access_delete_event          (GtkWidget       *widget,
					GdkEvent        *event,
					gpointer         user_data);
void
on_module_access_ok_clicked            (GtkButton       *button,
					gpointer         user_data);
void
on_module_access_cancel_clicked        (GtkButton       *button,
					gpointer         user_data);
gboolean
on_address_access_delete_event         (GtkWidget       *widget,
					GdkEvent        *event,
					gpointer         user_data);
void
on_address_ok_clicked                  (GtkButton       *button,
					gpointer         user_data);
void
on_address_cancel_clicked              (GtkButton       *button,
					gpointer         user_data);
void
on_admin_button_clicked                (GtkButton       *button,
					gpointer         user_data);
GtkWidget*
create_admin (void);
GtkWidget*
create_pass (void);
GtkWidget*
create_group (void);
GtkWidget*
create_user (void);
void
message (gchar *text);
GtkWidget*
create_module_access (void);
GtkWidget*
create_address_access (void);
GtkWidget*
create_groupdel (void);
GtkWidget*
create_base (void);
void
update_admin_widget(GtkWidget *top);
GtkWidget *create_pixmap(GtkWidget *w, char *file);
void add_pixmap_directory(char *dir);


gboolean
on_groupdel_delete_event         (GtkWidget       *widget,
				  GdkEvent        *event,
				  gpointer         user_data)
{
   return FALSE;
   widget = NULL;
   event = NULL;
   user_data = NULL;
}

void
on_groupdel_del_clicked                (GtkButton       *button,
					gpointer         user_data)
{
   GtkWidget *w, *top, *admin;
   Nexxus *nx;
   
   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   nx = gtk_object_get_data(GTK_OBJECT(top), "nexxus");
   admin = gtk_object_get_data(GTK_OBJECT(top), "admin");
   w = gtk_object_get_data(GTK_OBJECT(top), "groupdel_list");

     {
	GList *l;
	
	for (l = GTK_CLIST(w)->row_list; l; l = l->next)
	  {
	     GtkCListRow *row;
	     
	     row = l->data;
	     if (row->state == GTK_STATE_SELECTED)
	       {
		  GtkCellText *cell;
		  
		  cell = (GtkCellText *)row->cell;
		    {
		       gchar buf[4096];
		       
		       g_snprintf(buf, sizeof(buf), "NEXXUS:GROUP_DEL:%s", cell->text);
		       FLIM_COMMS_BEGIN(nx->connection, buf);
		       while (FLIM_COMMS_REPLY)
			 {
			    if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2])) break;
			    if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2])) 
			      {
				 g_snprintf(buf, sizeof(buf),
					    "There was an error deleting the group:\n"
					    "%s\n"
					    "Error:\n"
					    "%s", cell->text, FLIM_COMMS_REPLY[3]);
				 message(buf);
				 break;
			      }
			    FILM_COMMS_GET_REPLY;
			 }
		       FILM_COMMS_REPLY_END;   
		    }
	       }
	  }	
     }
   gtk_widget_destroy(top);
   update_admin_widget(admin);
   button = NULL;
   user_data = NULL;
}


void
on_groupdel_cancel_clicked             (GtkButton       *button,
					gpointer         user_data)
{
   GtkWidget *top;
   
   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   gtk_widget_destroy(top);
   button = NULL;
   user_data = NULL;
}

gboolean
on_admin_delete_event                  (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

  return FALSE;
   widget = NULL;
   event = NULL;
   user_data = NULL;
}

void
on_groups_select_row                    (GtkCList        *clist,
					 gint             row,
					 gint             column,
					 GdkEvent        *event,
					 gpointer         user_data)
{
   GtkWidget *w, *top;
   Nexxus *nx;
   gchar *user = NULL, *group;

   top = gtk_widget_get_toplevel(GTK_WIDGET(clist));
   nx = gtk_object_get_data(GTK_OBJECT(top), "nexxus");
   w = gtk_object_get_data(GTK_OBJECT(top), "users");
     {
	GList *l;
	
	for (l = GTK_CLIST(w)->row_list; l; l = l->next)
	  {
	     GtkCListRow *row;
	     
	     row = l->data;
	     if (row->state == GTK_STATE_SELECTED)
	       {
		  GtkCellText *cell;
		  
		  cell = (GtkCellText *)row->cell;
		  user = (gchar *)cell->text;
	       }
	  }	
     }
     {
	gchar buf[4096];
	
	gtk_clist_get_text(GTK_CLIST(clist), row, column, &group);
	g_snprintf(buf, sizeof(buf), "NEXXUS:GROUP_ADD_ADMIN:%s:%s", group, user);
	FLIM_COMMS_BEGIN(nx->connection, buf);
	while (FLIM_COMMS_REPLY)
	  {
	     if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2])) break;
	     if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2])) 
	       {
		  g_snprintf(buf, sizeof(buf),
			     "There was an error adding\n"
			     "to the user:\n"
			     "%s\n"
			     "to the group:\n"
			     "%s\n"
			     "Error:\n"
			     "%s", user, group, FLIM_COMMS_REPLY[3]);
		  message(buf);
		  break;
	       }
	     FILM_COMMS_GET_REPLY;
	  }
	FILM_COMMS_REPLY_END;
     }
   update_admin_widget(top);
   clist = NULL;
   row = 0;
   column = 0;
   event = NULL;
   user_data = NULL;
}

void
on_groups_unselect_row                    (GtkCList        *clist,
					   gint             row,
					   gint             column,
					   GdkEvent        *event,
					   gpointer         user_data)
{
   GtkWidget *w, *top;
   Nexxus *nx;
   gchar *user = NULL, *group;

   top = gtk_widget_get_toplevel(GTK_WIDGET(clist));
   nx = gtk_object_get_data(GTK_OBJECT(top), "nexxus");
   w = gtk_object_get_data(GTK_OBJECT(top), "users");
     {
	GList *l;
	
	for (l = GTK_CLIST(w)->row_list; l; l = l->next)
	  {
	     GtkCListRow *row;
	     
	     row = l->data;
	     if (row->state == GTK_STATE_SELECTED)
	       {
		  GtkCellText *cell;
		  
		  cell = (GtkCellText *)row->cell;
		  user = (gchar *)cell->text;
	       }
	  }	
     }
     {
	gchar buf[4096];
	
	gtk_clist_get_text(GTK_CLIST(clist), row, column, &group);
	g_snprintf(buf, sizeof(buf), "NEXXUS:GROUP_DEL_ADMIN:%s:%s", group, user);
	FLIM_COMMS_BEGIN(nx->connection, buf);
	while (FLIM_COMMS_REPLY)
	  {
	     if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2])) break;
	     if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2])) 
	       {
		  g_snprintf(buf, sizeof(buf),
			     "There was an error adding\n"
			     "to the user:\n"
			     "%s\n"
			     "to the group:\n"
			     "%s\n"
			     "Error:\n"
			     "%s", user, group, FLIM_COMMS_REPLY[3]);
		  message(buf);
		  break;
	       }
	     FILM_COMMS_GET_REPLY;
	  }
	FILM_COMMS_REPLY_END;
     }
   update_admin_widget(top);
   clist = NULL;
   row = 0;
   column = 0;
   event = NULL;
   user_data = NULL;
}

void
on_users_select_row                    (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
   GtkWidget *w, *top;
   Nexxus *nx;

   top = gtk_widget_get_toplevel(GTK_WIDGET(clist));
   nx = gtk_object_get_data(GTK_OBJECT(top), "nexxus");
   w = gtk_object_get_data(GTK_OBJECT(top), "users");
     {
	GList *l;
	
	for (l = GTK_CLIST(w)->row_list; l; l = l->next)
	  {
	     GtkCListRow *row;
	     
	     row = l->data;
	     if (row->state == GTK_STATE_SELECTED)
	       {
		  GtkCellText *cell;
		  
		  cell = (GtkCellText *)row->cell;
		    {
		       gchar buf[4096];
		       GtkWidget *ww;
		       
		       ww = gtk_object_get_data(GTK_OBJECT(top), "modules");
		       gtk_clist_clear(GTK_CLIST(ww));
		       
		       g_snprintf(buf, sizeof(buf), "NEXXUS:ADMIN_LIST_MOD_ACL_RULES:%s", cell->text);
		       FLIM_COMMS_BEGIN(nx->connection, buf);
		       while (FLIM_COMMS_REPLY)
			 {
			    if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2])) break;
			    if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2])) 
			      {
				 g_snprintf(buf, sizeof(buf),
					    "There was an error obtaining\n"
					    "the module ACL rules for the user:\n"
					    "%s\n"
					    "Error:\n"
					    "%s", cell->text, FLIM_COMMS_REPLY[3]);
				 message(buf);
				 break;
			      }
			    if (!strcmp("MOD_ACL_RULE", FLIM_COMMS_REPLY[2]))
			      {
				 gchar *text[3];
				 
				 text[0] = FLIM_COMMS_REPLY[3];
				 text[1] = FLIM_COMMS_REPLY[5];
				 text[2] = FLIM_COMMS_REPLY[4];
				 gtk_clist_append(GTK_CLIST(ww), text);
			      }
			    FILM_COMMS_GET_REPLY;
			 }
		       FILM_COMMS_REPLY_END;   
		    }
		    {
		       gchar buf[4096];
		       GtkWidget *ww;
		       
		       ww = gtk_object_get_data(GTK_OBJECT(top), "address");
		       gtk_clist_clear(GTK_CLIST(ww));
		       
		       g_snprintf(buf, sizeof(buf), "NEXXUS:ADMIN_LIST_ADDR_ACL_RULES:%s", cell->text);
		       FLIM_COMMS_BEGIN(nx->connection, buf);
		       while (FLIM_COMMS_REPLY)
			 {
			    if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2])) break;
			    if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2])) 
			      {
				 g_snprintf(buf, sizeof(buf),
					    "There was an error obtaining\n"
					    "the address ACL rules for the user:\n"
					    "%s\n"
					    "Error:\n"
					    "%s", cell->text, FLIM_COMMS_REPLY[3]);
				 message(buf);
				 break;
			      }
			    if (!strcmp("ADDR_ACL_RULE", FLIM_COMMS_REPLY[2]))
			      {
				 gchar *text[3];
				 
				 text[0] = FLIM_COMMS_REPLY[4];
				 text[1] = FLIM_COMMS_REPLY[5];
				 text[2] = FLIM_COMMS_REPLY[3];
				 gtk_clist_append(GTK_CLIST(ww), text);
			      }
			    FILM_COMMS_GET_REPLY;
			 }
		       FILM_COMMS_REPLY_END;   
		    }
		    {
		       gchar buf[4096];
		       GtkWidget *ww;
		       
		       ww = gtk_object_get_data(GTK_OBJECT(top), "groups");
		       
		       gtk_signal_handler_block_by_func(GTK_OBJECT(ww), 
							GTK_SIGNAL_FUNC(on_groups_select_row), 
							NULL);
		       gtk_signal_handler_block_by_func(GTK_OBJECT(ww), 
							GTK_SIGNAL_FUNC(on_groups_unselect_row), 
							NULL);
		       gtk_clist_clear(GTK_CLIST(ww));
		       
		       g_snprintf(buf, sizeof(buf), "NEXXUS:GROUP_LIST");
		       FLIM_COMMS_BEGIN(nx->connection, buf);
		       while (FLIM_COMMS_REPLY)
			 {
			    if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2])) break;
			    if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2])) 
			      {
				 g_snprintf(buf, sizeof(buf),
					    "There was an error obtaining\n"
					    "the list of groups\n"
					    "Error:\n"
					    "%s", FLIM_COMMS_REPLY[3]);
				 message(buf);
				 break;
			      }
			    if (!strcmp("GROUP_LIST", FLIM_COMMS_REPLY[2]))
			      {
				 gchar *text[1];
				 
				 text[0] = FLIM_COMMS_REPLY[3];
				 gtk_clist_append(GTK_CLIST(ww), text);
			      }
			    FILM_COMMS_GET_REPLY;
			 }
		       FILM_COMMS_REPLY_END;
		       
		       g_snprintf(buf, sizeof(buf), "NEXXUS:ADMIN_LIST_GROUPS:%s", cell->text);
		       FLIM_COMMS_BEGIN(nx->connection, buf);
		       while (FLIM_COMMS_REPLY)
			 {
			    if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2])) break;
			    if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2])) 
			      {
				 g_snprintf(buf, sizeof(buf),
					    "There was an error obtaining\n"
					    "the groups for the user:\n"
					    "%s\n"
					    "Error:\n"
					    "%s", cell->text, FLIM_COMMS_REPLY[3]);
				 message(buf);
				 break;
			      }
			    if (!strcmp("ADMIN_LIST_GROUPS", FLIM_COMMS_REPLY[2]))
			      {
				 GList *ll;
				 int num;
				 
				 for (num = 0, ll = GTK_CLIST(ww)->row_list; ll; ll = ll->next, num++)
				   {
				      GtkCListRow *row2;
				      GtkCellText *cell2;
				      
				      row2 = ll->data;
				      cell2 = (GtkCellText *)row2->cell;
				      if (!strcmp(cell2->text, FLIM_COMMS_REPLY[3]))
					 gtk_clist_select_row(GTK_CLIST(ww), num, 0);
				   }
					   
			      }
			    FILM_COMMS_GET_REPLY;
			 }
		       FILM_COMMS_REPLY_END;   
		       gtk_signal_handler_unblock_by_func(GTK_OBJECT(ww), 
							  GTK_SIGNAL_FUNC(on_groups_select_row), 
							  NULL);
		       gtk_signal_handler_unblock_by_func(GTK_OBJECT(ww), 
							  GTK_SIGNAL_FUNC(on_groups_unselect_row), 
							  NULL);
		    }
	       }
	  }	
     }
   clist = NULL;
   row = 0;
   column = 0;
   event = NULL;
   user_data = NULL;
}


void
on_add_user_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *w, *top;
   Nexxus *nx;

   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   nx = gtk_object_get_data(GTK_OBJECT(top), "nexxus");   
   w = create_user();
   gtk_object_set_data(GTK_OBJECT(w), "nexxus", nx);   
   gtk_object_set_data(GTK_OBJECT(w), "admin", top);   
   gtk_widget_show(w);
   button = NULL;
   user_data = NULL;
}


void
on_del_user_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *w, *top;
   Nexxus *nx;
   gint error = 0;

   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   nx = gtk_object_get_data(GTK_OBJECT(top), "nexxus");
   w = gtk_object_get_data(GTK_OBJECT(top), "users");
     {
	GList *l;
	
	for (l = GTK_CLIST(w)->row_list; l; l = l->next)
	  {
	     GtkCListRow *row;
	     
	     row = l->data;
	     if (row->state == GTK_STATE_SELECTED)
	       {
		  GtkCellText *cell;
		  
		  cell = (GtkCellText *)row->cell;
		    {
		       gchar buf[4096];
		       
		       g_snprintf(buf, sizeof(buf), "NEXXUS:ADMIN_DEL:%s", cell->text);
		       FLIM_COMMS_BEGIN(nx->connection, buf);
		       while (FLIM_COMMS_REPLY)
			 {
			    if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2])) break;
			    if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2])) 
			      {
				 g_snprintf(buf, sizeof(buf),
					    "There was an error deleting the user:\n"
					    "%s\n"
					    "Error:\n"
					    "%s", cell->text, FLIM_COMMS_REPLY[3]);
				 message(buf);
				 error = 1;
				 break;
			      }
			    FILM_COMMS_GET_REPLY;
			 }
		       FILM_COMMS_REPLY_END;   
		    }
	       }
	  }	
     }
   if (!error)
      update_admin_widget(top);
   button = NULL;
   user_data = NULL;
}


void
on_pass_user_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *w, *top, *list;
   Nexxus *nx;

   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   nx = gtk_object_get_data(GTK_OBJECT(top), "nexxus");   
   w = create_pass();
   gtk_object_set_data(GTK_OBJECT(w), "nexxus", nx);   
   list = gtk_object_get_data(GTK_OBJECT(top), "users");
     {
	GList *l;
	
	for (l = GTK_CLIST(list)->row_list; l; l = l->next)
	  {
	     GtkCListRow *row;
	     
	     row = l->data;
	     if (row->state == GTK_STATE_SELECTED)
	       {
		  GtkCellText *cell;
		  
		  cell = (GtkCellText *)row->cell;
		  gtk_object_set_data(GTK_OBJECT(w), "user", cell->text);   
	       }
	  }	
     }
   gtk_widget_show(w);
   button = NULL;
   user_data = NULL;
}

void
on_group_add_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *w, *top;
   
   w = create_group();
   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   gtk_object_set_data(GTK_OBJECT(w), "top", top);
   gtk_widget_show(w);
   button = NULL;
   user_data = NULL;
}


void
on_group_del_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *w, *top, *list;
   Nexxus *nx;

   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   nx = gtk_object_get_data(GTK_OBJECT(top), "nexxus");

   w = create_groupdel();
   list = gtk_object_get_data(GTK_OBJECT(w), "groupdel_list");
     {
	gchar buf[4096];
	
	g_snprintf(buf, sizeof(buf), "NEXXUS:GROUP_LIST");
	FLIM_COMMS_BEGIN(nx->connection, buf);
	while (FLIM_COMMS_REPLY)
	  {
	     if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2])) break;
	     if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2])) 
	       {
		  g_snprintf(buf, sizeof(buf),
			     "There was an error obtaining\n"
			     "the list of groups\n"
			     "Error:\n"
			     "%s", FLIM_COMMS_REPLY[3]);
		  message(buf);
		  break;
	       }
	     if (!strcmp("GROUP_LIST", FLIM_COMMS_REPLY[2]))
	       {
		  gchar *text[1];
		  
		  text[0] = FLIM_COMMS_REPLY[3];
		  gtk_clist_append(GTK_CLIST(list), text);
	       }
	     FILM_COMMS_GET_REPLY;
	  }
	FILM_COMMS_REPLY_END;
     }
   gtk_object_set_data(GTK_OBJECT(w), "nexxus", nx);
   gtk_object_set_data(GTK_OBJECT(w), "admin", top);
   
   gtk_widget_show(w);   
   button = NULL;
   user_data = NULL;
}


void
on_module_add_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *w, *top, *list, *entry;
   Nexxus *nx;
   gint error = 0;
   
   w = create_module_access();
   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   nx = gtk_object_get_data(GTK_OBJECT(top), "nexxus");
   gtk_object_set_data(GTK_OBJECT(w), "top", top);
   list = gtk_object_get_data(GTK_OBJECT(w), "module_list");
     {
	gchar buf[4096];
	
	g_snprintf(buf, sizeof(buf), "NEXXUS:NEXXUS_MODULES");
	FLIM_COMMS_BEGIN(nx->connection, buf);
	while (FLIM_COMMS_REPLY)
	  {
	     gchar *text[1];
	     
	     if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2])) break;
	     if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2])) 
	       {
		  g_snprintf(buf, sizeof(buf),
			     "There was an error listing modules for nexxus:\n"
			     "%s\n"
			     "Error:\n"
			     "%s", nx->name, FLIM_COMMS_REPLY[3]);
		  message(buf);
		  gtk_widget_destroy(w);
		  error = 1;
		  break;
	       }
	     text[0] = FLIM_COMMS_REPLY[3];
	     gtk_clist_append(GTK_CLIST(list), text);
	     FILM_COMMS_GET_REPLY;
	  }
	FILM_COMMS_REPLY_END;   
     }
   entry = gtk_object_get_data(GTK_OBJECT(w), "module_mask");
   gtk_entry_set_text(GTK_ENTRY(entry), "*");
   if (error)
     gtk_widget_destroy(w);
   else
      gtk_widget_show(w);
   button = NULL;
   user_data = NULL;
}


void
on_module_del_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *w, *top;
   Nexxus *nx;
   gint error = 0;
   gchar *user = NULL;

   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   nx = gtk_object_get_data(GTK_OBJECT(top), "nexxus");
   w = gtk_object_get_data(GTK_OBJECT(top), "users");
     {
	GList *l;
	
	for (l = GTK_CLIST(w)->row_list; l; l = l->next)
	  {
	     GtkCListRow *row;
	     
	     row = l->data;
	     if (row->state == GTK_STATE_SELECTED)
	       {
		  GtkCellText *cell;
		  
		  cell = (GtkCellText *)row->cell;
		  user = cell->text;
	       }
	  }	
     }
   w = gtk_object_get_data(GTK_OBJECT(top), "modules");
     {
	GList *l;
	
	for (l = GTK_CLIST(w)->row_list; l; l = l->next)
	  {
	     GtkCListRow *row;
	     
	     row = l->data;
	     if (row->state == GTK_STATE_SELECTED)
	       {
		  GtkCellText *cell;
		  
		  cell = (GtkCellText *)row->cell;
		    {
		       gchar buf[4096];
		       
		       g_snprintf(buf, sizeof(buf), "NEXXUS:ADMIN_DEL_MOD_ACL_RULE:%s:%s:%s:%s", 
				  user, 
				  GTK_CELL_TEXT(row->cell[2])->text,
				  GTK_CELL_TEXT(row->cell[0])->text, 
				  GTK_CELL_TEXT(row->cell[1])->text);
		       FLIM_COMMS_BEGIN(nx->connection, buf);
		       while (FLIM_COMMS_REPLY)
			 {
			    if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2])) break;
			    if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2])) 
			      {
				 g_snprintf(buf, sizeof(buf),
					    "There was an error deleting module access:\n"
					    "%s %s %s\n"
					    "Error:\n"
					    "%s", 
					    GTK_CELL_TEXT(row->cell[0])->text,
					    GTK_CELL_TEXT(row->cell[1])->text, 
					    GTK_CELL_TEXT(row->cell[2])->text,
					    FLIM_COMMS_REPLY[3]);
				 message(buf);
				 error = 1;
				 break;
			      }
			    FILM_COMMS_GET_REPLY;
			 }
		       FILM_COMMS_REPLY_END;   
		    }
	       }
	  }	
     }
   if (!error)
      update_admin_widget(top);
   button = NULL;
   user_data = NULL;
}

void
on_address_add_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *w, *top;
   
   w = create_address_access();
   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   gtk_object_set_data(GTK_OBJECT(w), "top", top);
   gtk_widget_show(w);
   button = NULL;
   user_data = NULL;
}


void
on_address_del_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *w, *top;
   Nexxus *nx;
   gint error = 0;
   gchar *user = NULL;

   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   nx = gtk_object_get_data(GTK_OBJECT(top), "nexxus");
   w = gtk_object_get_data(GTK_OBJECT(top), "users");
     {
	GList *l;
	
	for (l = GTK_CLIST(w)->row_list; l; l = l->next)
	  {
	     GtkCListRow *row;
	     
	     row = l->data;
	     if (row->state == GTK_STATE_SELECTED)
	       {
		  GtkCellText *cell;
		  
		  cell = (GtkCellText *)row->cell;
		  user = cell->text;
	       }
	  }	
     }
   w = gtk_object_get_data(GTK_OBJECT(top), "address");
     {
	GList *l;
	
	for (l = GTK_CLIST(w)->row_list; l; l = l->next)
	  {
	     GtkCListRow *row;
	     
	     row = l->data;
	     if (row->state == GTK_STATE_SELECTED)
	       {
		  GtkCellText *cell;
		  
		  cell = (GtkCellText *)row->cell;
		    {
		       gchar buf[4096];
		       
		       g_snprintf(buf, sizeof(buf), "NEXXUS:ADMIN_DEL_ADDR_ACL_RULE:%s:%s:%s:%s", 
				  user, 
				  GTK_CELL_TEXT(row->cell[2])->text,
				  GTK_CELL_TEXT(row->cell[0])->text, 
				  GTK_CELL_TEXT(row->cell[1])->text);
		       FLIM_COMMS_BEGIN(nx->connection, buf);
		       while (FLIM_COMMS_REPLY)
			 {
			    if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2])) break;
			    if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2])) 
			      {
				 g_snprintf(buf, sizeof(buf),
					    "There was an error deleting address access:\n"
					    "%s %s %s\n"
					    "Error:\n"
					    "%s",
					    GTK_CELL_TEXT(row->cell[0])->text,
					    GTK_CELL_TEXT(row->cell[1])->text, 
					    GTK_CELL_TEXT(row->cell[2])->text,
					    FLIM_COMMS_REPLY[3]);
				 message(buf);
				 error = 1;
				 break;
			      }
			    FILM_COMMS_GET_REPLY;
			 }
		       FILM_COMMS_REPLY_END;   
		    }
	       }
	  }	
     }
   if (!error)
      update_admin_widget(top);
   button = NULL;
   user_data = NULL;
}

void
on_close_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *top;

   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   gtk_widget_destroy(top);
   button = NULL;
   user_data = NULL;
}


gboolean
on_pass_delete_event                   (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

  return FALSE;
   widget = NULL;
   event = NULL;
   user_data = NULL;
}


void
on_pass_ok_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *top, *w;
   Nexxus *nx;
   gchar *p1, *p2, *p3, *n, buf[4096];
   gint error = 0;

   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   nx = gtk_object_get_data(GTK_OBJECT(top), "nexxus");

   w = gtk_object_get_data(GTK_OBJECT(top), "pass1");
   p1 = gtk_entry_get_text(GTK_ENTRY(w));
   w = gtk_object_get_data(GTK_OBJECT(top), "pass2");
   p2 = gtk_entry_get_text(GTK_ENTRY(w));
   w = gtk_object_get_data(GTK_OBJECT(top), "pass3");
   p3 = gtk_entry_get_text(GTK_ENTRY(w));
   n = gtk_object_get_data(GTK_OBJECT(top), "user");
   if (strcmp(p2, p3))
     {
	message("The 2 passwords typed in don't match.\n"
		"Please make sure the 2 password fields\n"
		"are identical");
	return;
     }
   g_snprintf(buf, sizeof(buf), "NEXXUS:ADMIN_CHG_PASSWORD::%s:%s", p1, p2);
   FLIM_COMMS_BEGIN(nx->connection, buf);
   while (FLIM_COMMS_REPLY)
     {
	if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2])) break;
	if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2])) 
	   {
	      g_snprintf(buf, sizeof(buf),
			 "There was an error changing the user password:\n"
			 "%s\n"
			 "Error:\n"
			 "%s", n, FLIM_COMMS_REPLY[3]);
	      message(buf);
	      error = 1;
	      break;
	   }
	FILM_COMMS_GET_REPLY;
     }
   FILM_COMMS_REPLY_END;   

   if (!error)
      update_admin_widget(top);
   
   gtk_widget_destroy(top);
   button = NULL;
   user_data = NULL;
}

void
on_group_ok_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *top, *entry, *old_top;
   gchar *group;
   Nexxus *nx;
   gint error = 0;
   
   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   entry = gtk_object_get_data(GTK_OBJECT(top), "group");
   group = gtk_entry_get_text(GTK_ENTRY(entry));
   old_top = top;
   top = gtk_object_get_data(GTK_OBJECT(top), "top");
   nx = gtk_object_get_data(GTK_OBJECT(top), "nexxus");
     {
	gchar buf[4096];
	
	g_snprintf(buf, sizeof(buf), "NEXXUS:GROUP_ADD:%s", group);
	FLIM_COMMS_BEGIN(nx->connection, buf);
	while (FLIM_COMMS_REPLY)
	  {
	     if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2])) break;
	     if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2])) 
	       {
		  g_snprintf(buf, sizeof(buf),
			     "There was an error adding the group:\n"
			     "%s\n"
			     "Error:\n"
			     "%s", group, FLIM_COMMS_REPLY[3]);
		  message(buf);
		  error = 1;
		  break;
	       }
	     FILM_COMMS_GET_REPLY;
	  }
	FILM_COMMS_REPLY_END;   
     }
   
   if (!error)
      update_admin_widget(top);

   gtk_widget_destroy(old_top);
   button = NULL;
   user_data = NULL;   
}


gboolean
on_user_delete_event                   (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

  return FALSE;
   widget = NULL;
   event = NULL;
   user_data = NULL;
}


void
on_user_close_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *top, *w;
   Nexxus *nx;
   gchar *p1, *p2, *n, buf[4096];
   gint error = 0;

   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   nx = gtk_object_get_data(GTK_OBJECT(top), "nexxus");

   w = gtk_object_get_data(GTK_OBJECT(top), "userpass1");
   p1 = gtk_entry_get_text(GTK_ENTRY(w));
   w = gtk_object_get_data(GTK_OBJECT(top), "userpass2");
   p2 = gtk_entry_get_text(GTK_ENTRY(w));
   w = gtk_object_get_data(GTK_OBJECT(top), "username");
   n = gtk_entry_get_text(GTK_ENTRY(w));
   if (strcmp(p1, p2))
     {
	message("The 2 passwords typed in don't match.\n"
		"Please make sure the 2 password fields\n"
		"are identical");
	return;
     }
   g_snprintf(buf, sizeof(buf), "NEXXUS:ADMIN_ADD:%s:%s:default", n, p1);
   FLIM_COMMS_BEGIN(nx->connection, buf);
   while (FLIM_COMMS_REPLY)
     {
	if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2])) break;
	if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2])) 
	   {
	      g_snprintf(buf, sizeof(buf),
			 "There was an error adding the user:\n"
			 "%s\n"
			 "Error:\n"
			 "%s", n, FLIM_COMMS_REPLY[3]);
	      message(buf);
	      error = 1;
	      break;
	   }
	FILM_COMMS_GET_REPLY;
     }
   FILM_COMMS_REPLY_END;   

   if (!error)
     {
	w = gtk_object_get_data(GTK_OBJECT(top), "admin");
	update_admin_widget(w);
	gtk_widget_destroy(top);
     }
   button = NULL;
   user_data = NULL;
}


gboolean
on_message_delete_event                (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

  return FALSE;
   widget = NULL;
   event = NULL;
   user_data = NULL;
}


void
on_message_ok_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *top;

   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   gtk_widget_destroy(top);
   button = NULL;
   user_data = NULL;
}


gboolean
on_module_access_delete_event          (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  return FALSE;
   widget = NULL;
   event = NULL;
   user_data = NULL;
}


void
on_module_access_ok_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *top, *admin, *list, *entry, *allow;   
   gchar *access, *module = NULL, *glob, *user = NULL;
   Nexxus *nx;
   gint error = 0;

   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   
   admin = gtk_object_get_data(GTK_OBJECT(top), "top");
   nx = gtk_object_get_data(GTK_OBJECT(admin), "nexxus");
   
   list = gtk_object_get_data(GTK_OBJECT(admin), "users");

    {
	GList *l;
	
	for (l = GTK_CLIST(list)->row_list; l; l = l->next)
	  {
	     GtkCListRow *row;
	     
	     row = l->data;
	     if (row->state == GTK_STATE_SELECTED)
	       {
		  GtkCellText *cell;
		  
		  cell = (GtkCellText *)row->cell;
		  user = cell->text;
	       }
	  }	
     }
   
   list = gtk_object_get_data(GTK_OBJECT(top), "module_list");
   entry = gtk_object_get_data(GTK_OBJECT(top), "module_mask");
   allow = gtk_object_get_data(GTK_OBJECT(top), "module_allow");

     {
	GList *l;
	
	for (l = GTK_CLIST(list)->row_list; l; l = l->next)
	  {
	     GtkCListRow *row;
	     
	     row = l->data;
	     if (row->state == GTK_STATE_SELECTED)
	       {
		  GtkCellText *cell;
		  
		  cell = (GtkCellText *)row->cell;
		  module = cell->text;
	       }
	  }	
     }
   
   glob = gtk_entry_get_text(GTK_ENTRY(entry));
   if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(allow)))
      access = "ALLOW";
   else
      access = "DENY";

     {
	gchar buf[4096];
	
	g_snprintf(buf, sizeof(buf), "NEXXUS:ADMIN_ADD_MOD_ACL_RULE:%s:%s:%s:%s", 
		   user, access, module, glob);
	FLIM_COMMS_BEGIN(nx->connection, buf);
	while (FLIM_COMMS_REPLY)
	  {
	     if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2])) break;
	     if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2])) 
	       {
		  g_snprintf(buf, sizeof(buf),
			     "There was an error adding\n"
			     "module access for user:\n"
			     "%s\n"
			     "Error:\n"
			     "%s", user, FLIM_COMMS_REPLY[3]);
		  message(buf);
		  error = 1;
		  break;
	       }
	     FILM_COMMS_GET_REPLY;
	  }
	FILM_COMMS_REPLY_END;   
     }
   if (!error)
      update_admin_widget(admin);
   
   gtk_widget_destroy(top);
   button = NULL;
   user_data = NULL;
}


void
on_module_access_cancel_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *top;

   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   gtk_widget_destroy(top);
   button = NULL;
   user_data = NULL;
}


gboolean
on_address_access_delete_event         (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

  return FALSE;
   widget = NULL;
   event = NULL;
   user_data = NULL;
}


void
on_address_ok_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *top, *admin, *ip, *allow, *list;
   GtkAdjustment *adj;
   gchar *access, *address, *user = NULL;
   Nexxus *nx;
   gint bits;
   gint error = 0;

   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   
   admin = gtk_object_get_data(GTK_OBJECT(top), "top");
   nx = gtk_object_get_data(GTK_OBJECT(admin), "nexxus");
   
   list = gtk_object_get_data(GTK_OBJECT(admin), "users");

    {
	GList *l;
	
	for (l = GTK_CLIST(list)->row_list; l; l = l->next)
	  {
	     GtkCListRow *row;
	     
	     row = l->data;
	     if (row->state == GTK_STATE_SELECTED)
	       {
		  GtkCellText *cell;
		  
		  cell = (GtkCellText *)row->cell;
		  user = cell->text;
	       }
	  }	
     }
   
   ip = gtk_object_get_data(GTK_OBJECT(top), "ip_address");
   adj = gtk_object_get_data(GTK_OBJECT(top), "address_network_adj");
   allow = gtk_object_get_data(GTK_OBJECT(top), "address_allow");
   
   bits = (gint)(adj->value);
   address = gtk_entry_get_text(GTK_ENTRY(ip));
   if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(allow)))
      access = "ALLOW";
   else
      access = "DENY";

     {
	gchar buf[4096];
	
	g_snprintf(buf, sizeof(buf), "NEXXUS:ADMIN_ADD_ADDR_ACL_RULE:%s:%s:%s:%i", 
		   user, access, address, bits);
	FLIM_COMMS_BEGIN(nx->connection, buf);
	while (FLIM_COMMS_REPLY)
	  {
	     if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2])) break;
	     if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2])) 
	       {
		  g_snprintf(buf, sizeof(buf),
			     "There was an error adding\n"
			     "address access for user:\n"
			     "%s\n"
			     "Error:\n"
			     "%s", user, FLIM_COMMS_REPLY[3]);
		  message(buf);
		  error = 1;
		  break;
	       }
	     FILM_COMMS_GET_REPLY;
	  }
	FILM_COMMS_REPLY_END;   
     }
   if (!error)
      update_admin_widget(admin);
   
   gtk_widget_destroy(top);
   button = NULL;
   user_data = NULL;
}


void
on_address_cancel_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *top;

   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   gtk_widget_destroy(top);
   button = NULL;
   user_data = NULL;
}

GtkWidget*
create_admin (void)
{
  GtkWidget *admin;
  GtkWidget *dialog_vbox1;
  GtkWidget *hbox1;
  GtkWidget *vbox1;
  GtkWidget *scrolledwindow1;
  GtkWidget *users;
  GtkWidget *label5;
  GtkWidget *hbox2;
  GtkWidget *add_user;
  GtkWidget *del_user;
  GtkWidget *pass_user;
  GtkWidget *vseparator1;
  GtkWidget *notebook1;
  GtkWidget *vbox2;
  GtkWidget *scrolledwindow2;
  GtkWidget *groups;
  GtkWidget *label6;
  GtkWidget *hbox3;
  GtkWidget *group_add;
  GtkWidget *group_del;
  GtkWidget *label2;
  GtkWidget *vbox3;
  GtkWidget *scrolledwindow3;
  GtkWidget *modules;
  GtkWidget *label11;
  GtkWidget *label12;
  GtkWidget *label13;
  GtkWidget *hbox4;
  GtkWidget *module_add;
  GtkWidget *module_del;
  GtkWidget *label3;
  GtkWidget *vbox4;
  GtkWidget *scrolledwindow4;
  GtkWidget *address;
  GtkWidget *label8;
  GtkWidget *label9;
  GtkWidget *label10;
  GtkWidget *hbox5;
  GtkWidget *address_add;
  GtkWidget *address_del;
  GtkWidget *label4;
  GtkWidget *dialog_action_area1;
  GtkWidget *close;

  admin = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (admin), "admin", admin);
  gtk_widget_set_usize (admin, 500, 320);
  gtk_window_set_title (GTK_WINDOW (admin), _("User Administration"));
  gtk_window_set_policy (GTK_WINDOW (admin), FALSE, TRUE, TRUE);
  gtk_window_set_wmclass (GTK_WINDOW (admin), "Admin", "FLIM");

  dialog_vbox1 = GTK_DIALOG (admin)->vbox;
  gtk_object_set_data (GTK_OBJECT (admin), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (admin), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), hbox1, TRUE, TRUE, 0);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (admin), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox1, FALSE, FALSE, 0);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (admin), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow1), 4);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  users = gtk_clist_new (1);
  gtk_widget_ref (users);
  gtk_object_set_data_full (GTK_OBJECT (admin), "users", users,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (users);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), users);
  gtk_clist_set_column_width (GTK_CLIST (users), 0, 80);
  gtk_clist_set_selection_mode (GTK_CLIST (users), GTK_SELECTION_BROWSE);
  gtk_clist_column_titles_show (GTK_CLIST (users));

  label5 = gtk_label_new (_("Users"));
  gtk_widget_ref (label5);
  gtk_object_set_data_full (GTK_OBJECT (admin), "label5", label5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label5);
  gtk_clist_set_column_widget (GTK_CLIST (users), 0, label5);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (admin), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox2), 4);

  add_user = gtk_button_new_with_label (_("Add"));
  gtk_widget_ref (add_user);
  gtk_object_set_data_full (GTK_OBJECT (admin), "add_user", add_user,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (add_user);
  gtk_box_pack_start (GTK_BOX (hbox2), add_user, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (add_user), 2);

  del_user = gtk_button_new_with_label (_("Delete"));
  gtk_widget_ref (del_user);
  gtk_object_set_data_full (GTK_OBJECT (admin), "del_user", del_user,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (del_user);
  gtk_box_pack_start (GTK_BOX (hbox2), del_user, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (del_user), 2);

  pass_user = gtk_button_new_with_label (_("Password"));
  gtk_widget_ref (pass_user);
  gtk_object_set_data_full (GTK_OBJECT (admin), "pass_user", pass_user,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pass_user);
  gtk_box_pack_start (GTK_BOX (hbox2), pass_user, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (pass_user), 2);

  vseparator1 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator1);
  gtk_object_set_data_full (GTK_OBJECT (admin), "vseparator1", vseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator1);
  gtk_box_pack_start (GTK_BOX (hbox1), vseparator1, FALSE, FALSE, 4);

  notebook1 = gtk_notebook_new ();
  gtk_widget_ref (notebook1);
  gtk_object_set_data_full (GTK_OBJECT (admin), "notebook1", notebook1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (notebook1);
  gtk_box_pack_start (GTK_BOX (hbox1), notebook1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (notebook1), 4);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (admin), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (notebook1), vbox2);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (admin), "scrolledwindow2", scrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow2);
  gtk_box_pack_start (GTK_BOX (vbox2), scrolledwindow2, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  groups = gtk_clist_new (1);
  gtk_widget_ref (groups);
  gtk_object_set_data_full (GTK_OBJECT (admin), "groups", groups,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (groups);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), groups);
  gtk_container_set_border_width (GTK_CONTAINER (groups), 4);
  gtk_clist_set_column_width (GTK_CLIST (groups), 0, 80);
  gtk_clist_set_selection_mode (GTK_CLIST (groups), GTK_SELECTION_MULTIPLE);
  gtk_clist_column_titles_show (GTK_CLIST (groups));

  label6 = gtk_label_new (_("Group Names"));
  gtk_widget_ref (label6);
  gtk_object_set_data_full (GTK_OBJECT (admin), "label6", label6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label6);
  gtk_clist_set_column_widget (GTK_CLIST (groups), 0, label6);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox3);
  gtk_object_set_data_full (GTK_OBJECT (admin), "hbox3", hbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox3, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox3), 4);

  group_add = gtk_button_new_with_label (_("Add"));
  gtk_widget_ref (group_add);
  gtk_object_set_data_full (GTK_OBJECT (admin), "group_add", group_add,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (group_add);
  gtk_box_pack_start (GTK_BOX (hbox3), group_add, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (group_add), 2);

  group_del = gtk_button_new_with_label (_("Del"));
  gtk_widget_ref (group_del);
  gtk_object_set_data_full (GTK_OBJECT (admin), "group_del", group_del,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (group_del);
  gtk_box_pack_start (GTK_BOX (hbox3), group_del, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (group_del), 2);

  label2 = gtk_label_new (_("Groups"));
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (admin), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 0), label2);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox3);
  gtk_object_set_data_full (GTK_OBJECT (admin), "vbox3", vbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox3);
  gtk_container_add (GTK_CONTAINER (notebook1), vbox3);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow3);
  gtk_object_set_data_full (GTK_OBJECT (admin), "scrolledwindow3", scrolledwindow3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow3);
  gtk_box_pack_start (GTK_BOX (vbox3), scrolledwindow3, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  modules = gtk_clist_new (3);
  gtk_widget_ref (modules);
  gtk_object_set_data_full (GTK_OBJECT (admin), "modules", modules,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (modules);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), modules);
  gtk_container_set_border_width (GTK_CONTAINER (modules), 4);
  gtk_clist_set_column_width (GTK_CLIST (modules), 0, 80);
  gtk_clist_set_column_width (GTK_CLIST (modules), 1, 80);
  gtk_clist_set_column_width (GTK_CLIST (modules), 2, 80);
  gtk_clist_set_selection_mode (GTK_CLIST (modules), GTK_SELECTION_BROWSE);
  gtk_clist_column_titles_show (GTK_CLIST (modules));

  label11 = gtk_label_new (_("Module"));
  gtk_widget_ref (label11);
  gtk_object_set_data_full (GTK_OBJECT (admin), "label11", label11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label11);
  gtk_clist_set_column_widget (GTK_CLIST (modules), 0, label11);

  label12 = gtk_label_new (_("Match"));
  gtk_widget_ref (label12);
  gtk_object_set_data_full (GTK_OBJECT (admin), "label12", label12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label12);
  gtk_clist_set_column_widget (GTK_CLIST (modules), 1, label12);

  label13 = gtk_label_new (_("Access"));
  gtk_widget_ref (label13);
  gtk_object_set_data_full (GTK_OBJECT (admin), "label13", label13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label13);
  gtk_clist_set_column_widget (GTK_CLIST (modules), 2, label13);

  hbox4 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox4);
  gtk_object_set_data_full (GTK_OBJECT (admin), "hbox4", hbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox4);
  gtk_box_pack_start (GTK_BOX (vbox3), hbox4, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox4), 4);

  module_add = gtk_button_new_with_label (_("Add"));
  gtk_widget_ref (module_add);
  gtk_object_set_data_full (GTK_OBJECT (admin), "module_add", module_add,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (module_add);
  gtk_box_pack_start (GTK_BOX (hbox4), module_add, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (module_add), 2);

  module_del = gtk_button_new_with_label (_("Del"));
  gtk_widget_ref (module_del);
  gtk_object_set_data_full (GTK_OBJECT (admin), "module_del", module_del,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (module_del);
  gtk_box_pack_start (GTK_BOX (hbox4), module_del, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (module_del), 2);

  label3 = gtk_label_new (_("Module Access Rules"));
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (admin), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 1), label3);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox4);
  gtk_object_set_data_full (GTK_OBJECT (admin), "vbox4", vbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (notebook1), vbox4);

  scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow4);
  gtk_object_set_data_full (GTK_OBJECT (admin), "scrolledwindow4", scrolledwindow4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow4);
  gtk_box_pack_start (GTK_BOX (vbox4), scrolledwindow4, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  address = gtk_clist_new (3);
  gtk_widget_ref (address);
  gtk_object_set_data_full (GTK_OBJECT (admin), "address", address,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (address);
  gtk_container_add (GTK_CONTAINER (scrolledwindow4), address);
  gtk_container_set_border_width (GTK_CONTAINER (address), 4);
  gtk_clist_set_column_width (GTK_CLIST (address), 0, 80);
  gtk_clist_set_column_width (GTK_CLIST (address), 1, 80);
  gtk_clist_set_column_width (GTK_CLIST (address), 2, 80);
  gtk_clist_set_selection_mode (GTK_CLIST (address), GTK_SELECTION_BROWSE);
  gtk_clist_column_titles_show (GTK_CLIST (address));

  label8 = gtk_label_new (_("Address"));
  gtk_widget_ref (label8);
  gtk_object_set_data_full (GTK_OBJECT (admin), "label8", label8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label8);
  gtk_clist_set_column_widget (GTK_CLIST (address), 0, label8);

  label9 = gtk_label_new (_("Network"));
  gtk_widget_ref (label9);
  gtk_object_set_data_full (GTK_OBJECT (admin), "label9", label9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label9);
  gtk_clist_set_column_widget (GTK_CLIST (address), 1, label9);

  label10 = gtk_label_new (_("Access"));
  gtk_widget_ref (label10);
  gtk_object_set_data_full (GTK_OBJECT (admin), "label10", label10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label10);
  gtk_clist_set_column_widget (GTK_CLIST (address), 2, label10);

  hbox5 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox5);
  gtk_object_set_data_full (GTK_OBJECT (admin), "hbox5", hbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox5);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox5, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox5), 4);

  address_add = gtk_button_new_with_label (_("Add"));
  gtk_widget_ref (address_add);
  gtk_object_set_data_full (GTK_OBJECT (admin), "address_add", address_add,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (address_add);
  gtk_box_pack_start (GTK_BOX (hbox5), address_add, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (address_add), 2);

  address_del = gtk_button_new_with_label (_("Del"));
  gtk_widget_ref (address_del);
  gtk_object_set_data_full (GTK_OBJECT (admin), "address_del", address_del,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (address_del);
  gtk_box_pack_start (GTK_BOX (hbox5), address_del, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (address_del), 2);

  label4 = gtk_label_new (_("Address Access Rules"));
  gtk_widget_ref (label4);
  gtk_object_set_data_full (GTK_OBJECT (admin), "label4", label4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label4);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 2), label4);

  dialog_action_area1 = GTK_DIALOG (admin)->action_area;
  gtk_object_set_data (GTK_OBJECT (admin), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  close = gtk_button_new_with_label (_("Close"));
  gtk_widget_ref (close);
  gtk_object_set_data_full (GTK_OBJECT (admin), "close", close,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (close);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), close, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (close, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (admin), "delete_event",
                      GTK_SIGNAL_FUNC (on_admin_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (users), "select_row",
                      GTK_SIGNAL_FUNC (on_users_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (add_user), "clicked",
                      GTK_SIGNAL_FUNC (on_add_user_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (del_user), "clicked",
                      GTK_SIGNAL_FUNC (on_del_user_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (pass_user), "clicked",
                      GTK_SIGNAL_FUNC (on_pass_user_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (group_add), "clicked",
                      GTK_SIGNAL_FUNC (on_group_add_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (group_del), "clicked",
                      GTK_SIGNAL_FUNC (on_group_del_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (module_add), "clicked",
                      GTK_SIGNAL_FUNC (on_module_add_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (module_del), "clicked",
                      GTK_SIGNAL_FUNC (on_module_del_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (address_add), "clicked",
                      GTK_SIGNAL_FUNC (on_address_add_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (address_del), "clicked",
                      GTK_SIGNAL_FUNC (on_address_del_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (close), "clicked",
                      GTK_SIGNAL_FUNC (on_close_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (groups), "select_row",
                      GTK_SIGNAL_FUNC (on_groups_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (groups), "unselect_row",
                      GTK_SIGNAL_FUNC (on_groups_unselect_row),
                      NULL);

  gtk_widget_grab_default (close);
  return admin;
}

GtkWidget*
create_pass (void)
{
  GtkWidget *pass;
  GtkWidget *dialog_vbox2;
  GtkWidget *table1;
  GtkWidget *pass1;
  GtkWidget *pass2;
  GtkWidget *pass3;
  GtkWidget *label999;
  GtkWidget *lable998;
  GtkWidget *lable997;
  GtkWidget *dialog_action_area2;
  GtkWidget *pass_close;

  pass = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (pass), "pass", pass);
  gtk_window_set_title (GTK_WINDOW (pass), _("Change Password"));
  GTK_WINDOW (pass)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_modal (GTK_WINDOW (pass), TRUE);
  gtk_window_set_policy (GTK_WINDOW (pass), FALSE, TRUE, TRUE);
  gtk_window_set_wmclass (GTK_WINDOW (pass), "Password", "FLIM");

  dialog_vbox2 = GTK_DIALOG (pass)->vbox;
  gtk_object_set_data (GTK_OBJECT (pass), "dialog_vbox2", dialog_vbox2);
  gtk_widget_show (dialog_vbox2);

  table1 = gtk_table_new (2, 2, FALSE);
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (pass), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox2), table1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 4);
  gtk_table_set_row_spacings (GTK_TABLE (table1), 4);
  gtk_table_set_col_spacings (GTK_TABLE (table1), 4);

  pass1 = gtk_entry_new ();
  gtk_widget_ref (pass1);
  gtk_object_set_data_full (GTK_OBJECT (pass), "pass1", pass1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pass1);
  gtk_table_attach (GTK_TABLE (table1), pass1, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_visibility (GTK_ENTRY (pass1), FALSE);

  pass2 = gtk_entry_new ();
  gtk_widget_ref (pass2);
  gtk_object_set_data_full (GTK_OBJECT (pass), "pass2", pass2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pass2);
  gtk_table_attach (GTK_TABLE (table1), pass2, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_visibility (GTK_ENTRY (pass2), FALSE);

  pass3 = gtk_entry_new ();
  gtk_widget_ref (pass3);
  gtk_object_set_data_full (GTK_OBJECT (pass), "pass3", pass3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pass3);
  gtk_table_attach (GTK_TABLE (table1), pass3, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_visibility (GTK_ENTRY (pass3), FALSE);
   
  label999 = gtk_label_new (_("Old Password:"));
  gtk_widget_ref (label999);
  gtk_object_set_data_full (GTK_OBJECT (pass), "label999", label999,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label999);
  gtk_table_attach (GTK_TABLE (table1), label999, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label999), GTK_JUSTIFY_RIGHT);

  lable998 = gtk_label_new (_("Password:"));
  gtk_widget_ref (lable998);
  gtk_object_set_data_full (GTK_OBJECT (pass), "lable998", lable998,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (lable998);
  gtk_table_attach (GTK_TABLE (table1), lable998, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  lable997 = gtk_label_new (_("Confirm:"));
  gtk_widget_ref (lable997);
  gtk_object_set_data_full (GTK_OBJECT (pass), "lable997", lable997,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (lable997);
  gtk_table_attach (GTK_TABLE (table1), lable997, 0, 1, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
   
  dialog_action_area2 = GTK_DIALOG (pass)->action_area;
  gtk_object_set_data (GTK_OBJECT (pass), "dialog_action_area2", dialog_action_area2);
  gtk_widget_show (dialog_action_area2);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area2), 10);

  pass_close = gtk_button_new_with_label (_("OK"));
  gtk_widget_ref (pass_close);
  gtk_object_set_data_full (GTK_OBJECT (pass), "pass_close", pass_close,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pass_close);
  gtk_box_pack_start (GTK_BOX (dialog_action_area2), pass_close, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (pass_close, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (pass), "delete_event",
                      GTK_SIGNAL_FUNC (on_pass_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (pass_close), "clicked",
                      GTK_SIGNAL_FUNC (on_pass_ok_clicked),
                      NULL);

  gtk_widget_grab_default (pass_close);
  return pass;
}

GtkWidget*
create_group (void)
{
  GtkWidget *pass;
  GtkWidget *dialog_vbox2;
  GtkWidget *table1;
  GtkWidget *pass1;
  GtkWidget *label999;
  GtkWidget *dialog_action_area2;
  GtkWidget *pass_close;

  pass = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (pass), "group", pass);
  gtk_window_set_title (GTK_WINDOW (pass), _("New Group"));
  GTK_WINDOW (pass)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_modal (GTK_WINDOW (pass), TRUE);
  gtk_window_set_policy (GTK_WINDOW (pass), FALSE, TRUE, TRUE);
  gtk_window_set_wmclass (GTK_WINDOW (pass), "Group", "FLIM");

  dialog_vbox2 = GTK_DIALOG (pass)->vbox;
  gtk_object_set_data (GTK_OBJECT (pass), "dialog_vbox2", dialog_vbox2);
  gtk_widget_show (dialog_vbox2);

  table1 = gtk_table_new (2, 2, FALSE);
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (pass), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox2), table1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 4);
  gtk_table_set_row_spacings (GTK_TABLE (table1), 4);
  gtk_table_set_col_spacings (GTK_TABLE (table1), 4);

  pass1 = gtk_entry_new ();
  gtk_widget_ref (pass1);
  gtk_object_set_data_full (GTK_OBJECT (pass), "group", pass1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pass1);
  gtk_table_attach (GTK_TABLE (table1), pass1, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  label999 = gtk_label_new (_("Group Name:"));
  gtk_widget_ref (label999);
  gtk_object_set_data_full (GTK_OBJECT (pass), "label999", label999,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label999);
  gtk_table_attach (GTK_TABLE (table1), label999, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label999), GTK_JUSTIFY_RIGHT);

  dialog_action_area2 = GTK_DIALOG (pass)->action_area;
  gtk_object_set_data (GTK_OBJECT (pass), "dialog_action_area2", dialog_action_area2);
  gtk_widget_show (dialog_action_area2);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area2), 10);

  pass_close = gtk_button_new_with_label (_("OK"));
  gtk_widget_ref (pass_close);
  gtk_object_set_data_full (GTK_OBJECT (pass), "group_ok", pass_close,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pass_close);
  gtk_box_pack_start (GTK_BOX (dialog_action_area2), pass_close, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (pass_close, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (pass), "delete_event",
                      GTK_SIGNAL_FUNC (on_pass_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (pass_close), "clicked",
                      GTK_SIGNAL_FUNC (on_group_ok_clicked),
                      NULL);

  gtk_widget_grab_default (pass_close);
  return pass;
}

GtkWidget*
create_user (void)
{
  GtkWidget *user;
  GtkWidget *dialog_vbox3;
  GtkWidget *table2;
  GtkWidget *label16;
  GtkWidget *label17;
  GtkWidget *label18;
  GtkWidget *username;
  GtkWidget *userpass1;
  GtkWidget *userpass2;
  GtkWidget *dialog_action_area3;
  GtkWidget *user_close;

  user = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (user), "user", user);
  gtk_window_set_title (GTK_WINDOW (user), _("New User"));
  GTK_WINDOW (user)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_modal (GTK_WINDOW (user), TRUE);
  gtk_window_set_policy (GTK_WINDOW (user), FALSE, TRUE, TRUE);
  gtk_window_set_wmclass (GTK_WINDOW (user), "NewUser", "FLIM");

  dialog_vbox3 = GTK_DIALOG (user)->vbox;
  gtk_object_set_data (GTK_OBJECT (user), "dialog_vbox3", dialog_vbox3);
  gtk_widget_show (dialog_vbox3);

  table2 = gtk_table_new (3, 2, FALSE);
  gtk_widget_ref (table2);
  gtk_object_set_data_full (GTK_OBJECT (user), "table2", table2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table2);
  gtk_box_pack_start (GTK_BOX (dialog_vbox3), table2, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table2), 4);
  gtk_table_set_row_spacings (GTK_TABLE (table2), 4);
  gtk_table_set_col_spacings (GTK_TABLE (table2), 4);

  label16 = gtk_label_new (_("Login:"));
  gtk_widget_ref (label16);
  gtk_object_set_data_full (GTK_OBJECT (user), "label16", label16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label16);
  gtk_table_attach (GTK_TABLE (table2), label16, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label17 = gtk_label_new (_("Password:"));
  gtk_widget_ref (label17);
  gtk_object_set_data_full (GTK_OBJECT (user), "label17", label17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label17);
  gtk_table_attach (GTK_TABLE (table2), label17, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label18 = gtk_label_new (_("Confirm:"));
  gtk_widget_ref (label18);
  gtk_object_set_data_full (GTK_OBJECT (user), "label18", label18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label18);
  gtk_table_attach (GTK_TABLE (table2), label18, 0, 1, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  username = gtk_entry_new ();
  gtk_widget_ref (username);
  gtk_object_set_data_full (GTK_OBJECT (user), "username", username,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (username);
  gtk_table_attach (GTK_TABLE (table2), username, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  userpass1 = gtk_entry_new ();
  gtk_widget_ref (userpass1);
  gtk_object_set_data_full (GTK_OBJECT (user), "userpass1", userpass1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (userpass1);
  gtk_table_attach (GTK_TABLE (table2), userpass1, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_visibility (GTK_ENTRY (userpass1), FALSE);

  userpass2 = gtk_entry_new ();
  gtk_widget_ref (userpass2);
  gtk_object_set_data_full (GTK_OBJECT (user), "userpass2", userpass2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (userpass2);
  gtk_table_attach (GTK_TABLE (table2), userpass2, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_visibility (GTK_ENTRY (userpass2), FALSE);

  dialog_action_area3 = GTK_DIALOG (user)->action_area;
  gtk_object_set_data (GTK_OBJECT (user), "dialog_action_area3", dialog_action_area3);
  gtk_widget_show (dialog_action_area3);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area3), 10);

  user_close = gtk_button_new_with_label (_("OK"));
  gtk_widget_ref (user_close);
  gtk_object_set_data_full (GTK_OBJECT (user), "user_close", user_close,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (user_close);
  gtk_box_pack_start (GTK_BOX (dialog_action_area3), user_close, TRUE, TRUE, 0);
  GTK_WIDGET_UNSET_FLAGS (user_close, GTK_CAN_FOCUS);
  GTK_WIDGET_SET_FLAGS (user_close, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (user), "delete_event",
                      GTK_SIGNAL_FUNC (on_user_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (user_close), "clicked",
                      GTK_SIGNAL_FUNC (on_user_close_clicked),
                      NULL);

  return user;
}

void
message (gchar *text)
{
  GtkWidget *message;
  GtkWidget *dialog_vbox4;
  GtkWidget *message_label;
  GtkWidget *dialog_action_area4;
  GtkWidget *message_ok;

  message = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (message), "message", message);
  gtk_window_set_title (GTK_WINDOW (message), _("Alert!"));
  GTK_WINDOW (message)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_modal (GTK_WINDOW (message), TRUE);
  gtk_window_set_policy (GTK_WINDOW (message), FALSE, FALSE, TRUE);
  gtk_window_set_wmclass (GTK_WINDOW (message), "Alert", "FLIM");

  dialog_vbox4 = GTK_DIALOG (message)->vbox;
  gtk_object_set_data (GTK_OBJECT (message), "dialog_vbox4", dialog_vbox4);
  gtk_widget_show (dialog_vbox4);

  message_label = gtk_label_new (text);
  gtk_widget_ref (message_label);
  gtk_object_set_data_full (GTK_OBJECT (message), "message_label", message_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (message_label);
  gtk_box_pack_start (GTK_BOX (dialog_vbox4), message_label, FALSE, FALSE, 0);
  gtk_misc_set_padding (GTK_MISC (message_label), 4, 4);

  dialog_action_area4 = GTK_DIALOG (message)->action_area;
  gtk_object_set_data (GTK_OBJECT (message), "dialog_action_area4", dialog_action_area4);
  gtk_widget_show (dialog_action_area4);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area4), 10);

  message_ok = gtk_button_new_with_label (_("OK"));
  gtk_widget_ref (message_ok);
  gtk_object_set_data_full (GTK_OBJECT (message), "message_ok", message_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (message_ok);
  gtk_box_pack_start (GTK_BOX (dialog_action_area4), message_ok, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (message_ok, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (message), "delete_event",
                      GTK_SIGNAL_FUNC (on_message_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (message_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_message_ok_clicked),
                      NULL);

  gtk_widget_grab_default (message_ok);
  gtk_widget_show(message);
}

GtkWidget*
create_module_access (void)
{
  GtkWidget *module_access;
  GtkWidget *dialog_vbox5;
  GtkWidget *hbox6;
  GtkWidget *scrolledwindow5;
  GtkWidget *module_list;
  GtkWidget *label20;
  GtkWidget *vbox5;
  GtkWidget *hbox7;
  GSList *hbox7_group = NULL;
  GtkWidget *module_allow;
  GtkWidget *module_deny;
  GtkWidget *hbox8;
  GtkWidget *label21;
  GtkWidget *module_mask;
  GtkWidget *dialog_action_area5;
  GtkWidget *module_access_ok;
  GtkWidget *module_access_cancel;

  module_access = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (module_access), "module_access", module_access);
  gtk_window_set_title (GTK_WINDOW (module_access), _("Module Access Rules"));
  GTK_WINDOW (module_access)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_policy (GTK_WINDOW (module_access), FALSE, FALSE, TRUE);

  dialog_vbox5 = GTK_DIALOG (module_access)->vbox;
  gtk_object_set_data (GTK_OBJECT (module_access), "dialog_vbox5", dialog_vbox5);
  gtk_widget_show (dialog_vbox5);

  hbox6 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox6);
  gtk_object_set_data_full (GTK_OBJECT (module_access), "hbox6", hbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox6);
  gtk_box_pack_start (GTK_BOX (dialog_vbox5), hbox6, TRUE, TRUE, 4);

  scrolledwindow5 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow5);
  gtk_object_set_data_full (GTK_OBJECT (module_access), "scrolledwindow5", scrolledwindow5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow5);
  gtk_box_pack_start (GTK_BOX (hbox6), scrolledwindow5, TRUE, TRUE, 4);
  gtk_widget_set_usize (scrolledwindow5, 120, 120);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow5), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  module_list = gtk_clist_new (1);
  gtk_widget_ref (module_list);
  gtk_object_set_data_full (GTK_OBJECT (module_access), "module_list", module_list,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (module_list);
  gtk_container_add (GTK_CONTAINER (scrolledwindow5), module_list);
  gtk_clist_set_column_width (GTK_CLIST (module_list), 0, 80);
  gtk_clist_set_selection_mode (GTK_CLIST (module_list), GTK_SELECTION_BROWSE);
  gtk_clist_column_titles_show (GTK_CLIST (module_list));

  label20 = gtk_label_new (_("Modules"));
  gtk_widget_ref (label20);
  gtk_object_set_data_full (GTK_OBJECT (module_access), "label20", label20,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label20);
  gtk_clist_set_column_widget (GTK_CLIST (module_list), 0, label20);

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox5);
  gtk_object_set_data_full (GTK_OBJECT (module_access), "vbox5", vbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox5);
  gtk_box_pack_start (GTK_BOX (hbox6), vbox5, FALSE, FALSE, 4);

  hbox7 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox7);
  gtk_object_set_data_full (GTK_OBJECT (module_access), "hbox7", hbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox7);
  gtk_box_pack_start (GTK_BOX (vbox5), hbox7, FALSE, TRUE, 4);

  module_allow = gtk_radio_button_new_with_label (hbox7_group, _("Allow"));
  hbox7_group = gtk_radio_button_group (GTK_RADIO_BUTTON (module_allow));
  gtk_widget_ref (module_allow);
  gtk_object_set_data_full (GTK_OBJECT (module_access), "module_allow", module_allow,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (module_allow);
  gtk_box_pack_start (GTK_BOX (hbox7), module_allow, FALSE, FALSE, 0);

  module_deny = gtk_radio_button_new_with_label (hbox7_group, _("Deny"));
  hbox7_group = gtk_radio_button_group (GTK_RADIO_BUTTON (module_deny));
  gtk_widget_ref (module_deny);
  gtk_object_set_data_full (GTK_OBJECT (module_access), "module_deny", module_deny,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (module_deny);
  gtk_box_pack_start (GTK_BOX (hbox7), module_deny, FALSE, FALSE, 0);

  hbox8 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox8);
  gtk_object_set_data_full (GTK_OBJECT (module_access), "hbox8", hbox8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox8);
  gtk_box_pack_start (GTK_BOX (vbox5), hbox8, FALSE, FALSE, 4);

  label21 = gtk_label_new (_("Match:"));
  gtk_widget_ref (label21);
  gtk_object_set_data_full (GTK_OBJECT (module_access), "label21", label21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label21);
  gtk_box_pack_start (GTK_BOX (hbox8), label21, FALSE, FALSE, 0);
  gtk_misc_set_padding (GTK_MISC (label21), 4, 4);

  module_mask = gtk_entry_new ();
  gtk_widget_ref (module_mask);
  gtk_object_set_data_full (GTK_OBJECT (module_access), "module_mask", module_mask,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (module_mask);
  gtk_box_pack_start (GTK_BOX (hbox8), module_mask, TRUE, TRUE, 0);

  dialog_action_area5 = GTK_DIALOG (module_access)->action_area;
  gtk_object_set_data (GTK_OBJECT (module_access), "dialog_action_area5", dialog_action_area5);
  gtk_widget_show (dialog_action_area5);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area5), 10);

  module_access_ok = gtk_button_new_with_label (_("OK"));
  gtk_widget_ref (module_access_ok);
  gtk_object_set_data_full (GTK_OBJECT (module_access), "module_access_ok", module_access_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (module_access_ok);
  gtk_box_pack_start (GTK_BOX (dialog_action_area5), module_access_ok, TRUE, TRUE, 0);

  module_access_cancel = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_ref (module_access_cancel);
  gtk_object_set_data_full (GTK_OBJECT (module_access), "module_access_cancel", module_access_cancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (module_access_cancel);
  gtk_box_pack_start (GTK_BOX (dialog_action_area5), module_access_cancel, TRUE, TRUE, 0);

  gtk_signal_connect (GTK_OBJECT (module_access), "delete_event",
                      GTK_SIGNAL_FUNC (on_module_access_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (module_access_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_module_access_ok_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (module_access_cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_module_access_cancel_clicked),
                      NULL);

  return module_access;
}

GtkWidget*
create_address_access (void)
{
  GtkWidget *address_access;
  GtkWidget *vbox6;
  GtkWidget *hbox10;
  GtkWidget *hbox13;
  GtkWidget *label24;
  GtkWidget *ip_address;
  GtkWidget *vbox7;
  GtkWidget *hbox11;
  GSList *hbox11_group = NULL;
  GtkWidget *address_allow;
  GtkWidget *address_deny;
  GtkWidget *hbox12;
  GtkWidget *label23;
  GtkObject *address_network_adj;
  GtkWidget *address_network;
  GtkWidget *hbox9;
  GtkWidget *address_ok;
  GtkWidget *address_cancel;

  address_access = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (address_access), "address_access", address_access);
  gtk_window_set_title (GTK_WINDOW (address_access), _("Address Access Rules"));
  GTK_WINDOW (address_access)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_policy (GTK_WINDOW (address_access), FALSE, FALSE, TRUE);

  vbox6 = GTK_DIALOG (address_access)->vbox;
  gtk_object_set_data (GTK_OBJECT (address_access), "vbox6", vbox6);
  gtk_widget_show (vbox6);

  hbox10 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox10);
  gtk_object_set_data_full (GTK_OBJECT (address_access), "hbox10", hbox10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox10);
  gtk_box_pack_start (GTK_BOX (vbox6), hbox10, TRUE, TRUE, 4);

  hbox13 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox13);
  gtk_object_set_data_full (GTK_OBJECT (address_access), "hbox13", hbox13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox13);
  gtk_box_pack_start (GTK_BOX (hbox10), hbox13, TRUE, TRUE, 4);

  label24 = gtk_label_new (_("IP Address:"));
  gtk_widget_ref (label24);
  gtk_object_set_data_full (GTK_OBJECT (address_access), "label24", label24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label24);
  gtk_box_pack_start (GTK_BOX (hbox13), label24, FALSE, FALSE, 0);
  gtk_misc_set_padding (GTK_MISC (label24), 4, 4);

  ip_address = gtk_entry_new ();
  gtk_widget_ref (ip_address);
  gtk_object_set_data_full (GTK_OBJECT (address_access), "ip_address", ip_address,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ip_address);
  gtk_box_pack_start (GTK_BOX (hbox13), ip_address, TRUE, TRUE, 0);

  vbox7 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox7);
  gtk_object_set_data_full (GTK_OBJECT (address_access), "vbox7", vbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox7);
  gtk_box_pack_start (GTK_BOX (hbox10), vbox7, FALSE, FALSE, 4);

  hbox11 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox11);
  gtk_object_set_data_full (GTK_OBJECT (address_access), "hbox11", hbox11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox11);
  gtk_box_pack_start (GTK_BOX (vbox7), hbox11, FALSE, TRUE, 4);

  address_allow = gtk_radio_button_new_with_label (hbox11_group, _("Allow"));
  hbox11_group = gtk_radio_button_group (GTK_RADIO_BUTTON (address_allow));
  gtk_widget_ref (address_allow);
  gtk_object_set_data_full (GTK_OBJECT (address_access), "address_allow", address_allow,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (address_allow);
  gtk_box_pack_start (GTK_BOX (hbox11), address_allow, FALSE, FALSE, 0);

  address_deny = gtk_radio_button_new_with_label (hbox11_group, _("Deny"));
  hbox11_group = gtk_radio_button_group (GTK_RADIO_BUTTON (address_deny));
  gtk_widget_ref (address_deny);
  gtk_object_set_data_full (GTK_OBJECT (address_access), "address_deny", address_deny,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (address_deny);
  gtk_box_pack_start (GTK_BOX (hbox11), address_deny, FALSE, FALSE, 0);

  hbox12 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox12);
  gtk_object_set_data_full (GTK_OBJECT (address_access), "hbox12", hbox12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox12);
  gtk_box_pack_start (GTK_BOX (vbox7), hbox12, FALSE, FALSE, 4);

  label23 = gtk_label_new (_("Network Size"));
  gtk_widget_ref (label23);
  gtk_object_set_data_full (GTK_OBJECT (address_access), "label23", label23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label23);
  gtk_box_pack_start (GTK_BOX (hbox12), label23, FALSE, FALSE, 0);
  gtk_misc_set_padding (GTK_MISC (label23), 4, 4);

  address_network_adj = gtk_adjustment_new (1, 1, 32, 1, 1, 1);
  address_network = gtk_spin_button_new (GTK_ADJUSTMENT (address_network_adj), 1, 0);
  gtk_widget_ref (address_network);
  gtk_object_set_data_full (GTK_OBJECT (address_access), "address_network", address_network,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (address_network);
  gtk_box_pack_start (GTK_BOX (hbox12), address_network, TRUE, TRUE, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (address_network), TRUE);

  hbox9 = GTK_DIALOG (address_access)->action_area;
  gtk_object_set_data (GTK_OBJECT (address_access), "hbox9", hbox9);
  gtk_widget_show (hbox9);
  gtk_container_set_border_width (GTK_CONTAINER (hbox9), 10);

  address_ok = gtk_button_new_with_label (_("OK"));
  gtk_widget_ref (address_ok);
  gtk_object_set_data_full (GTK_OBJECT (address_access), "address_ok", address_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (address_ok);
  gtk_box_pack_start (GTK_BOX (hbox9), address_ok, TRUE, TRUE, 0);

  address_cancel = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_ref (address_cancel);
  gtk_object_set_data_full (GTK_OBJECT (address_access), "address_cancel", address_cancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (address_cancel);
  gtk_box_pack_start (GTK_BOX (hbox9), address_cancel, TRUE, TRUE, 0);

  gtk_signal_connect (GTK_OBJECT (address_access), "delete_event",
                      GTK_SIGNAL_FUNC (on_address_access_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (address_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_address_ok_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (address_cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_address_cancel_clicked),
                      NULL);

  return address_access;
}

GtkWidget*
create_groupdel (void)
{
   GtkWidget *groupdel;
   GtkWidget *dialog_vbox6;
   GtkWidget *scrolledwindow6;
   GtkWidget *groupdel_list;
   GtkWidget *label1000;
   GtkWidget *dialog_action_area6;
   GtkWidget *hbuttonbox1;
   GtkWidget *gorupdel_del;
   GtkWidget *groupdel_cancel;
   
   groupdel = gtk_dialog_new ();
   gtk_object_set_data (GTK_OBJECT (groupdel), "groupdel", groupdel);
   gtk_window_set_title (GTK_WINDOW (groupdel), _("Delete Selected Groups"));
   GTK_WINDOW (groupdel)->type = GTK_WINDOW_DIALOG;
   gtk_window_set_position (GTK_WINDOW (groupdel), GTK_WIN_POS_MOUSE);
   gtk_window_set_modal (GTK_WINDOW (groupdel), TRUE);
   gtk_window_set_policy (GTK_WINDOW (groupdel), FALSE, TRUE, TRUE);
   gtk_window_set_wmclass (GTK_WINDOW (groupdel), "Flim", "DeleteGroups");
   
   dialog_vbox6 = GTK_DIALOG (groupdel)->vbox;
   gtk_object_set_data (GTK_OBJECT (groupdel), "dialog_vbox6", dialog_vbox6);
   gtk_widget_show (dialog_vbox6);
   
   scrolledwindow6 = gtk_scrolled_window_new (NULL, NULL);
   gtk_widget_ref (scrolledwindow6);
   gtk_object_set_data_full (GTK_OBJECT (groupdel), "scrolledwindow6", scrolledwindow6,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (scrolledwindow6);
   gtk_box_pack_start (GTK_BOX (dialog_vbox6), scrolledwindow6, TRUE, TRUE, 0);
   gtk_widget_set_usize (scrolledwindow6, -2, 170);
   gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow6), 4);
   gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow6), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
   
   groupdel_list = gtk_clist_new (1);
   gtk_widget_ref (groupdel_list);
   gtk_object_set_data_full (GTK_OBJECT (groupdel), "groupdel_list", groupdel_list,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (groupdel_list);
   gtk_container_add (GTK_CONTAINER (scrolledwindow6), groupdel_list);
   gtk_clist_set_column_width (GTK_CLIST (groupdel_list), 0, 80);
   gtk_clist_set_selection_mode (GTK_CLIST (groupdel_list), GTK_SELECTION_MULTIPLE);
   gtk_clist_column_titles_show (GTK_CLIST (groupdel_list));
   
   label1000 = gtk_label_new (_("Groups to delete"));
   gtk_widget_ref (label1000);
   gtk_object_set_data_full (GTK_OBJECT (groupdel), "label1000", label1000,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (label1000);
   gtk_clist_set_column_widget (GTK_CLIST (groupdel_list), 0, label1000);
   
   dialog_action_area6 = GTK_DIALOG (groupdel)->action_area;
   gtk_object_set_data (GTK_OBJECT (groupdel), "dialog_action_area6", dialog_action_area6);
   gtk_widget_show (dialog_action_area6);
   gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area6), 10);
   
   hbuttonbox1 = gtk_hbutton_box_new ();
   gtk_widget_ref (hbuttonbox1);
   gtk_object_set_data_full (GTK_OBJECT (groupdel), "hbuttonbox1", hbuttonbox1,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (hbuttonbox1);
   gtk_box_pack_start (GTK_BOX (dialog_action_area6), hbuttonbox1, TRUE, TRUE, 0);
   
   gorupdel_del = gtk_button_new_with_label (_("Delete"));
   gtk_widget_ref (gorupdel_del);
   gtk_object_set_data_full (GTK_OBJECT (groupdel), "gorupdel_del", gorupdel_del,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (gorupdel_del);
   gtk_container_add (GTK_CONTAINER (hbuttonbox1), gorupdel_del);
   GTK_WIDGET_SET_FLAGS (gorupdel_del, GTK_CAN_DEFAULT);
   
   groupdel_cancel = gtk_button_new_with_label (_("Cancel"));
   gtk_widget_ref (groupdel_cancel);
   gtk_object_set_data_full (GTK_OBJECT (groupdel), "groupdel_cancel", groupdel_cancel,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (groupdel_cancel);
   gtk_container_add (GTK_CONTAINER (hbuttonbox1), groupdel_cancel);
   GTK_WIDGET_SET_FLAGS (groupdel_cancel, GTK_CAN_DEFAULT);
   
   gtk_signal_connect (GTK_OBJECT (groupdel), "delete_event",
		       GTK_SIGNAL_FUNC (on_groupdel_delete_event),
		       NULL);
   gtk_signal_connect (GTK_OBJECT (gorupdel_del), "clicked",
		       GTK_SIGNAL_FUNC (on_groupdel_del_clicked),
		       NULL);
   gtk_signal_connect (GTK_OBJECT (groupdel_cancel), "clicked",
		       GTK_SIGNAL_FUNC (on_groupdel_cancel_clicked),
		       NULL);
   
   return groupdel;
}


void
update_admin_widget(GtkWidget *top)
{
   GtkWidget *w;
   gchar buf[4096];
   Nexxus *nx;
   GList *l = NULL, *ll;
   gint last_selected = 0, i;
   
   nx = gtk_object_get_data(GTK_OBJECT(top), "nexxus");
   w = gtk_object_get_data(GTK_OBJECT(top), "users");
     {
	for (i = 0, l = GTK_CLIST(w)->row_list; l; l = l->next, i++)
	  {
	     GtkCListRow *row;
	     
	     row = l->data;
	     if (row->state == GTK_STATE_SELECTED)
		last_selected = i;
	  }	
     }
   l = NULL;
   g_snprintf(buf, sizeof(buf), "NEXXUS:ADMIN_LIST");
   gtk_clist_clear(GTK_CLIST(w));
   FLIM_COMMS_BEGIN(nx->connection, buf);
   while (FLIM_COMMS_REPLY)
     {
	if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2])) break;
	if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2])) break;
	if (!strcmp("ADMIN_LIST", FLIM_COMMS_REPLY[2]))
	   l = g_list_append(l, g_strdup(FLIM_COMMS_REPLY[3]));
	FILM_COMMS_GET_REPLY;
     }
   FILM_COMMS_REPLY_END;   
   for (ll = l; ll; ll = ll->next)
     {
	gchar *text[1];
	
	text[0] = ll->data;
	gtk_clist_append(GTK_CLIST(w), text);
	g_free(ll->data);
     }
   if (l) g_list_free(l);
   gtk_clist_select_row(GTK_CLIST(w), last_selected, 0);
}

void
flim_client_message(Msg *msg)
{
   if (!strcmp(msg->msg, "nexxus_add"))
     {
	Nexxus *nx;
	char nx_name[4096], nx_address[4096], nx_login[4096], nx_password[4096];
	
	nx = nexxus_new();
	nx_login[0] = 0;
	nx_password[0] = 0;
	sscanf(msg->dat, "%[^:]:%[^:]:%[^:]:%[^:]", nx_name, nx_address, nx_login, nx_password);
	nx->name = g_strdup(nx_name);
	nx->address = g_strdup(nx_address);
	nx->login = g_strdup(nx_login);
	nx->password = g_strdup(nx_password);
	nexxus_connect(nx);
     }
   else if (!strcmp(msg->msg, "nexxus_del"))
     {
	Nexxus *nx;
	
	nx = nexxus_find(msg->dat);
	if (nx) 
	  {
	     nexxus_free(nx);
	  }
     }
   else if (!strcmp(msg->msg, "nexxus_rename"))
     {
	Nexxus *nx;
	char nx_name[4096], nx_name2[4096];
	
	sscanf(msg->dat, "%[^:]:%[^:]", nx_name, nx_name2);
	nx = nexxus_find(nx_name);
	if (nx)
	  {
	     if (nx->name) g_free(nx->name);
	     nx->name = g_strdup(nx_name2);
	  }
     }
   else if (!strcmp(msg->msg, "nexxus_address"))
     {
	Nexxus *nx;
	char nx_name[4096], nx_addr[4096], nx_login[4096], nx_pass[4096];

	sscanf(msg->dat, "%[^:]:%[^:]:%[^:]:%[^:]", nx_name, nx_addr, nx_login, nx_pass);
	nx = nexxus_find(nx_name);
	if (nx)
	  {
	     if (nx->address) g_free(nx->address);
	     nx->address = g_strdup(nx_addr);
	     if (nx->login) g_free(nx->login);
	     nx->login = g_strdup(nx_login);
	     if (nx->password) g_free(nx->password);
	     nx->password = g_strdup(nx_pass);
	     if (nx->connection) flim_comms_disconnect_nexxus(nx->connection);
	     nx->connection = NULL;
	     nexxus_connect(nx);
	  }
     }
   else if (!strcmp(msg->msg, "node_add"))
     {
	Nexxus *nx;
	Node *nd;
	char nx_name[4096], nd_name[4096];
	
	sscanf(msg->dat, "%[^:]:%[^:]", nx_name, nd_name);
	nx = nexxus_find(nx_name);
	if (nx)
	  {
	     nd = node_new(nx);
	     nd->name = g_strdup(nd_name);
	     nd->data = NULL;
	  }
     }
   else if (!strcmp(msg->msg, "node_del"))
     {
	Node *nd;
	
	nd = node_find(msg->dat);
	if (nd)
	  {
	     node_free(nd);
	  }
     }
   else if (!strcmp(msg->msg, "node_rename"))
     {
	Node *nd;
	char nx_name[4096], nd_name[4096], nd_name2[4096], buf[4096];
	
	sscanf(msg->dat, "%[^:]:%[^:]:%[^:]", nx_name, nd_name, nd_name2);
	g_snprintf(buf, sizeof(buf), "%s:%s", nx_name, nd_name);
	nd = node_find(buf);
	if (nd)
	  {
             if (nd->name) g_free(nd->name);
	     nd->name = g_strdup(nd_name2);	     
	  }
     }
   else if (!strcmp(msg->msg, "nexxus_select"))
     {
	Nexxus *nx;

	nx = nexxus_find(msg->dat);
	if (nx) 
	   {
	      nx->selected = 1;
	   }
     }
   else if (!strcmp(msg->msg, "node_select"))
     {
	Node *nd;

	nd = node_find(msg->dat);
	if (nd) 
	  {
	     nd->selected = 1;
	  }
     }
   else if (!strcmp(msg->msg, "nexxus_unselect"))
     {
	Nexxus *nx;

	nx = nexxus_find(msg->dat);
	if (nx) 
	  {
	     nx->selected = 0;
	  }
     }
   else if (!strcmp(msg->msg, "node_unselect"))
     {
	Node *nd;

	nd = node_find(msg->dat);
	if (nd) 
	  {
	     nd->selected = 0;
	  }
     }
}

void
on_admin_button_clicked                (GtkButton       *button,
					gpointer         user_data)
{
   GList *l;
   
   for (l = nexxus_list; l; l = l->next)
     {
	Nexxus *nx;
	
	nx = l->data;
	if (nx->selected)
	  {
	     GtkWidget *admin;

	     admin = create_admin();
	     gtk_object_set_data(GTK_OBJECT(admin), "nexxus", nx);
	     update_admin_widget(admin);
	     gtk_widget_show(admin);
	  }
     }
   button = NULL;
   user_data = NULL;
}

GtkWidget *
create_base(void)
{
   GtkWidget *base;
   GtkWidget *vbox1;
   GtkWidget *button1;
   GtkWidget *pixmap1;
   
   base = gtk_window_new (GTK_WINDOW_TOPLEVEL);
   gtk_object_set_data (GTK_OBJECT (base), "base", base);
   gtk_container_set_border_width (GTK_CONTAINER (base), 0);
   gtk_window_set_title (GTK_WINDOW (base), "Flim");
   gtk_window_set_wmclass (GTK_WINDOW (base), "AdminBar", "FLIM");
   
   vbox1 = gtk_vbox_new (FALSE, 0);
   gtk_widget_ref (vbox1);
   gtk_object_set_data_full (GTK_OBJECT (base), "vbox1", vbox1,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (vbox1);
   gtk_container_add (GTK_CONTAINER (base), vbox1);
   
   button1 = gtk_button_new();
   gtk_widget_show(button1);
   gtk_box_pack_start (GTK_BOX (vbox1), button1, FALSE, FALSE, 0);
   gtk_object_set_data_full (GTK_OBJECT (base), "admin", button1,
			     (GtkDestroyNotify) gtk_widget_unref);

     {
	GtkTooltips *tt;
	
	tt = gtk_tooltips_new();
	gtk_tooltips_set_delay(GTK_TOOLTIPS(tt), 300);
	gtk_tooltips_enable(GTK_TOOLTIPS(tt));
	gtk_tooltips_set_tip(GTK_TOOLTIPS(tt), button1, 
			     _("Administrate access to selected nexxus")
			     , "");
     }
   
   
   pixmap1 = create_pixmap(base, "admin.xpm");
   gtk_widget_ref(pixmap1);
   gtk_object_set_data_full (GTK_OBJECT (base), "pixmap1", base,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (pixmap1);
   gtk_container_add (GTK_CONTAINER (button1), pixmap1);

   gtk_signal_connect (GTK_OBJECT (base), "destroy",
		       GTK_SIGNAL_FUNC (exit),
		       NULL);   
   gtk_signal_connect (GTK_OBJECT (button1), "clicked",
		       GTK_SIGNAL_FUNC (on_admin_button_clicked),
		       NULL);
   return base;
}

int
main(int argc, char **argv)
{
   Msg msg;
   
   flim_comms_do_gui(0);
   flim_client_init(argc, argv);
#ifdef ENABLE_NLS
   bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
   textdomain (PACKAGE);
#endif
   
   gtk_set_locale ();
   gtk_init (&argc, &argv);
   
   add_pixmap_directory (PACKAGE_DATA_DIR "/pixmaps");
   add_pixmap_directory (PACKAGE_SOURCE_DIR "/pixmaps");
   
   base = create_base();
   gtk_widget_realize(base);

   g_snprintf(msg.msg, sizeof(msg.msg), "is_toolbar");
   flim_client_send(&msg);   
   
   g_snprintf(msg.msg, sizeof(msg.msg), "window_id");
   g_snprintf(msg.dat, sizeof(msg.dat), "%i", (int)GDK_WINDOW_XWINDOW(base->window));
   flim_client_send(&msg);

   for (;;) { XEvent xev; if (XCheckTypedWindowEvent(GDK_WINDOW_XDISPLAY(base->window), GDK_WINDOW_XWINDOW(base->window), ReparentNotify, &xev)) break; usleep(100000); }
   gtk_widget_show(base);
   
   g_snprintf(msg.msg, sizeof(msg.msg), "ready");
   flim_client_send(&msg);
   
   gtk_main();
   return 0;
}
