#ifndef CLIENT_H
#define CLIENT_H 1

typedef struct _msg Msg;
typedef struct _nexxus Nexxus;
typedef struct _node Node;

struct _msg
{
   int  id;
   char msg[256];
   char dat[512];
};

struct _nexxus
{
   char  *name;
   char  *address;
   int    selected;
   void  *data;
   GList *nodes;
   char  *login;
   char  *password;
   void  *connection;
};

struct _node
{
   char   *name;
   int     selected;
   Nexxus *nexxus;
   void   *data;
};

Nexxus *nexxus_new(void);
void    nexxus_connect(Nexxus *nx);
Node   *node_new(Nexxus *nx);
void    nexxus_free(Nexxus *nx);
void    node_free(Node *nd);
Nexxus *nexxus_find(char *name);
Node   *node_find(char *name);

void flim_client_init(int argc, char **argv);
void flim_client_send(Msg *msg);
void flim_client_handle_messages(void);
void flim_client_block_messages(void);
void flim_client_unblock_messages(void);

extern GList *nexxus_list;

#endif
