#include "support.h"
#include "main.h"
#include <ctype.h>

void
on_auth_ok_clicked                     (GtkButton       *button,
					gpointer         user_data)
{
   button = NULL;
   user_data = NULL;
}

gboolean
on_main_delete_event                   (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
   flim_config_save();
   gtk_main_quit();
   return FALSE;
   widget = NULL;
   event = NULL;
   user_data = NULL;
}


void
on_exit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   flim_config_save();
   gtk_main_quit();
   menuitem = NULL;
   user_data = NULL;
}


void
on_select_all1_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   GList *l;
   
   for (l = nexxus_list; l ; l = l->next)
     {
	Nexxus *nx;
	GtkCTreeNode *ctree_node;
	
	nx = l->data;
	ctree_node = gtk_ctree_find_by_row_data(GTK_CTREE(node_tree), NULL, nx);
	if (ctree_node)
	   gtk_ctree_select(GTK_CTREE(node_tree), ctree_node);	
     }
   menuitem = NULL;
   user_data = NULL;
}


void
on_selection_clear1_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   GList *l;
   
   for (l = nexxus_list; l ; l = l->next)
     {
	Nexxus *nx;
	GtkCTreeNode *ctree_node;
	
	nx = l->data;
	ctree_node = gtk_ctree_find_by_row_data(GTK_CTREE(node_tree), NULL, nx);
	if (ctree_node)
	   gtk_ctree_unselect(GTK_CTREE(node_tree), ctree_node);	
     }
   menuitem = NULL;
   user_data = NULL;
}


void
on_nexxus1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   menuitem = NULL;
   user_data = NULL;
}


void
on_new3_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   Nexxus *nx;
   GtkWidget *dialog, *w;
   gchar name[256];

   nx = flim_nexxus_new();
   if (!flim_nexxus_find("New Nexxus"))
      nx->name = g_strdup("New Nexxus");
   else
     {
	int i = 0;
	
	do
	  {
	     g_snprintf(name, sizeof(name), "New Nexxus %i", i);
	     i++;
	  }
	while (flim_nexxus_find(name));
	nx->name = g_strdup(name);	
     }
   nx->address = g_strdup("nexxus");
   flim_nexxus_add(nx);

   dialog = create_nexxus_settings();
   w = gtk_object_get_data(GTK_OBJECT(dialog), "entry1");
   if (nx->name)
      gtk_entry_set_text(GTK_ENTRY(w), nx->name);
   else
      gtk_entry_set_text(GTK_ENTRY(w), "");
   w = gtk_object_get_data(GTK_OBJECT(dialog), "entry2");
   if (nx->address)
      gtk_entry_set_text(GTK_ENTRY(w), nx->address);
   else
      gtk_entry_set_text(GTK_ENTRY(w), "");
   w = gtk_object_get_data(GTK_OBJECT(dialog), "entry3");
   if (nx->login)
      gtk_entry_set_text(GTK_ENTRY(w), nx->login);
   else
      gtk_entry_set_text(GTK_ENTRY(w), "");
   w = gtk_object_get_data(GTK_OBJECT(dialog), "entry4");
   if (nx->password)
      gtk_entry_set_text(GTK_ENTRY(w), nx->password);
   else
      gtk_entry_set_text(GTK_ENTRY(w), "");
   gtk_object_set_data(GTK_OBJECT(dialog), "__nexxus", nx);
   gtk_object_set_data(GTK_OBJECT(dialog), "__new", nx);
   gtk_widget_show(dialog);
   flim_nexxus_build_tree(node_tree);
   menuitem = NULL;
   user_data = NULL;
}


void
on_delete1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   GList *l;
   int deleted = 0;

   l = nexxus_list;
   while (l)
     {
	Nexxus *nx;
	
	nx = l->data;
	l = l->next;
	if (nx->selected)
	  {
	     flim_nexxus_del(nx);
	     flim_nexxus_free(nx);
	     deleted = 1;
	  }
     }   
   flim_nexxus_build_tree(node_tree);
   if (!deleted)
      message(_("You have to have at least one Nexxus\n"
	      "selected to delete a Nexxus."));
   menuitem = NULL;
   user_data = NULL;
}


void
on_settings3_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   GList *l;
   int settings = 0;
   
   for (l = nexxus_list; l ; l = l->next)
     {
	Nexxus *nx;
	
	nx = l->data;
	if (nx->selected)
	  {
	     GtkWidget *dialog, *w;
	     
	     dialog = create_nexxus_settings();
	     w = gtk_object_get_data(GTK_OBJECT(dialog), "entry1");
	     if (nx->name)
		gtk_entry_set_text(GTK_ENTRY(w), nx->name);
	     else
		gtk_entry_set_text(GTK_ENTRY(w), "");
	     w = gtk_object_get_data(GTK_OBJECT(dialog), "entry2");
	     if (nx->address)
		gtk_entry_set_text(GTK_ENTRY(w), nx->address);
	     else
		gtk_entry_set_text(GTK_ENTRY(w), "");
	     w = gtk_object_get_data(GTK_OBJECT(dialog), "entry3");
	     if (nx->login)
		gtk_entry_set_text(GTK_ENTRY(w), nx->login);
	     else
		gtk_entry_set_text(GTK_ENTRY(w), "");
	     w = gtk_object_get_data(GTK_OBJECT(dialog), "entry4");
	     if (nx->password)
		gtk_entry_set_text(GTK_ENTRY(w), nx->password);
	     else
		gtk_entry_set_text(GTK_ENTRY(w), "");
	     gtk_object_set_data(GTK_OBJECT(dialog), "__nexxus", nx);
	     gtk_widget_show(dialog);
	     settings = 1;
	  }
     }
   if (!settings)
      message(_("You have to have at least one Nexxus\n"
	      "selected to change the settings of\n"
	      "a Nexxus."));      
   menuitem = NULL;
   user_data = NULL;
}


void
on_node1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   menuitem = NULL;
   user_data = NULL;
}


void
on_new5_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   GList *l;
   int added = 0;
   
   for (l = nexxus_list; l ; l = l->next)
     {
	Nexxus *nx;
	
	nx = l->data;
	if (nx->selected)
	  {
	     GtkWidget *dialog, *w;
	     Node *nd;
	     char buf[4096];
	     int nodecount = 0;
	     GList *ll;
		    
	     nd = flim_node_new();
	     if (!flim_node_find("New_Node", nx))
		nd->name = g_strdup("New_Node");
	     else
	       {
		  int i = 0;
		  gchar name[256];
		  
		  do
		    {
		       g_snprintf(name, sizeof(name), "New_Node_%i", i);
		       i++;
		    }
		  while (flim_node_find(name, nx));
		  nd->name = g_strdup(name);
	       }
	     for (ll = nx->nodes; ll; ll = ll->next, nodecount++);
	     g_snprintf(buf, sizeof(buf), "/dev/ttyR%i", nodecount);	     
	     nd->device = g_strdup(buf);
	     g_snprintf(buf, sizeof(buf), "NEXXUS:NODE_ADD:%s:default",
			nd->name);
	     FLIM_COMMS_BEGIN(nx->connection, buf);
	     FILM_COMMS_REPLY_END;
	     flim_nexxus_add_node(nx, nd);
	     dialog = create_node_settings();
	     w = gtk_object_get_data(GTK_OBJECT(dialog), "entry4");
	     if (nd->name)
		gtk_entry_set_text(GTK_ENTRY(w), nd->name);
	     else
		gtk_entry_set_text(GTK_ENTRY(w), "");
	     w = gtk_object_get_data(GTK_OBJECT(dialog), "entry5");
	     if (nd->address)
		gtk_entry_set_text(GTK_ENTRY(w), nd->address);
	     else
		gtk_entry_set_text(GTK_ENTRY(w), "");
	     w = gtk_object_get_data(GTK_OBJECT(dialog), "entry6");
	     if (nd->device)
		gtk_entry_set_text(GTK_ENTRY(w), nd->device);
	     else
		gtk_entry_set_text(GTK_ENTRY(w), "");
	     w = gtk_object_get_data(GTK_OBJECT(dialog), "entry7");
	     if (nd->password)
		gtk_entry_set_text(GTK_ENTRY(w), nd->password);
	     else
		gtk_entry_set_text(GTK_ENTRY(w), "");
	     w = gtk_object_get_data(GTK_OBJECT(dialog), "entry8");
	     if (nd->asset_tag)
		gtk_entry_set_text(GTK_ENTRY(w), nd->asset_tag);
	     else
		gtk_entry_set_text(GTK_ENTRY(w), "");
	     gtk_object_set_data(GTK_OBJECT(dialog), "__nexxus", nx);
	     gtk_object_set_data(GTK_OBJECT(dialog), "__node", nd);
	     gtk_widget_show(dialog);   
	     added = 1;
	     flim_nexxus_build_tree(node_tree);
	     return;
	  }
     }
   if (!added)
      message(_("You have to have just one Nexxus\n"
	      "selected to add a node to a Nexxus"));
   menuitem = NULL;
   user_data = NULL;
}


void
on_delete2_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   GList *l, *ll;
   int deleted = 0;
   
   for (l = nexxus_list; l ; l = l->next)
     {
	Nexxus *nx;
	
	nx = l->data;
	ll = nx->nodes;
	while (ll)
	  {
	     Node *nd;
	     
	     nd = ll->data;
	     ll = ll->next;
	     if (nd->selected)
	       {
		  char buf[4096];
		  
		  g_snprintf(buf, sizeof(buf), "NEXXUS:NODE_DEL:%s",
			     nd->name);
		  FLIM_COMMS_BEGIN(nx->connection, buf);
		  FILM_COMMS_REPLY_END;
		  
		  flim_nexxus_del_node(nx, nd);
		  flim_node_free(nd);
		  flim_nexxus_build_tree(node_tree);
		  deleted = 1;
	       }
	  }
     }
   if (!deleted)
      message(_("You have to have at least one Node\n"
	      "selected to delete a Node from a Nexxus."));
   menuitem = NULL;
   user_data = NULL;
}


void
on_settings2_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   GList *l, *ll;
   
   for (l = nexxus_list; l ; l = l->next)
     {
	Nexxus *nx;
	
	nx = l->data;
	for (ll = nx->nodes; ll; ll = ll->next)
	  {
	     Node *nd;
	     
	     nd = ll->data;
	     if (nd->selected)
	       {
		  GtkWidget *dialog, *w;
		  
		  dialog = create_node_settings();
		  w = gtk_object_get_data(GTK_OBJECT(dialog), "entry4");
		  if (nd->name)
		     gtk_entry_set_text(GTK_ENTRY(w), nd->name);
		  else
		     gtk_entry_set_text(GTK_ENTRY(w), "");
		  w = gtk_object_get_data(GTK_OBJECT(dialog), "entry5");
		  if (nd->address)
		     gtk_entry_set_text(GTK_ENTRY(w), nd->address);
		  else
		     gtk_entry_set_text(GTK_ENTRY(w), "");
		  w = gtk_object_get_data(GTK_OBJECT(dialog), "entry6");
		  if (nd->device)
		     gtk_entry_set_text(GTK_ENTRY(w), nd->device);
		  else
		     gtk_entry_set_text(GTK_ENTRY(w), "");
		  w = gtk_object_get_data(GTK_OBJECT(dialog), "entry7");
		  if (nd->password)
		     gtk_entry_set_text(GTK_ENTRY(w), nd->password);
		  else
		     gtk_entry_set_text(GTK_ENTRY(w), "");
		  w = gtk_object_get_data(GTK_OBJECT(dialog), "entry8");
		  if (nd->asset_tag)
		     gtk_entry_set_text(GTK_ENTRY(w), nd->asset_tag);
		  else
		     gtk_entry_set_text(GTK_ENTRY(w), "");
		  gtk_object_set_data(GTK_OBJECT(dialog), "__nexxus", nx);
		  gtk_object_set_data(GTK_OBJECT(dialog), "__node", nd);
		  gtk_widget_show(dialog);
	       }
	  }
     }
   menuitem = NULL;
   user_data = NULL;
}


void
on_group1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   menuitem = NULL;
   user_data = NULL;
}


void
on_new4_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   GList *l;
   Group *g;
   GtkWidget *dialog, *w;
   int selected = 0;
   
   for (l = nexxus_list; l; l = l->next)
     {
	Nexxus *nx;
	GList *ll;
	
	nx = l->data;
	if (nx->selected)
	   selected = 1;
	else
	  {
	     for (ll = nx->nodes; ll; ll = ll->next)
	       {
		  Node *nd;
		  
		  nd = ll->data;
		  if (nd->selected)
		     selected = 1;
	       }
	  }
     }
   if (!selected)
     {
	message(_("You need to have some Nexxus' or Nodes\n"
		"selected to create a group out of them.\n"));
	return;
     }
   
   dialog = create_group_settings();
   g = flim_group_new();
   if (!flim_group_find("New Group"))
      g->name = g_strdup("New Group");
   else	   
     {
	int i = 0;
	gchar name[256];
	
	do
	  {
	     g_snprintf(name, sizeof(name), "New Group %i", i);
	     i++;
	  }
	while (!flim_group_find(name));
	g->name = g_strdup(name);
	
     }
   for (l = nexxus_list; l; l = l->next)
     {
	Nexxus *nx;
	GList *ll;
	
	nx = l->data;
	if (nx->selected)
	   flim_group_add_member(g, nx);
	else
	  {
	     for (ll = nx->nodes; ll; ll = ll->next)
	       {
		  Node *nd;
		  
		  nd = ll->data;
		  if (nd->selected)
		     flim_group_add_member(g, nd);
	       }
	  }
     }
   w = gtk_object_get_data(GTK_OBJECT(dialog), "entry9");
   gtk_entry_set_text(GTK_ENTRY(w), g->name);
   gtk_object_set_data(GTK_OBJECT(dialog), "__group", g);
   gtk_widget_show(dialog);
   flim_group_build_list(group_list);
   menuitem = NULL;
   user_data = NULL;
}


void
on_delete3_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   GList *l;
   int deleted = 0;

   l = groups_list;
   while (l)
     {
	Group *g;
	
	g = l->data;
	l = l->next;
	if (g->selected)
	  {
	     flim_group_free(g);
	     deleted = 1;
	  }
     }
   flim_group_build_list(group_list);
   if (!deleted)
      message(_("You need to have at least one Group\n"
	      "selected to delete any Groups."));
   menuitem = NULL;
   user_data = NULL;
}


void
on_settings4_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   GList *l;
   
   for (l = groups_list; l; l = l->next)
     {
	Group *g;
	GtkWidget *dialog, *w;
	
	g = l->data;
	if (g->selected)
	  {
	     dialog = create_group_settings();
	     w = gtk_object_get_data(GTK_OBJECT(dialog), "entry9");
	     gtk_entry_set_text(GTK_ENTRY(w), g->name);
	     gtk_object_set_data(GTK_OBJECT(dialog), "__group", g);
	     gtk_widget_show(dialog);
	  }
     }
   menuitem = NULL;
   user_data = NULL;
}


void
on_preferences1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   GtkWidget *dialog, *l1, *l2;
   
   dialog = create_prefs();
   l1 = gtk_object_get_data(GTK_OBJECT(dialog), "clist1");
   l2 = gtk_object_get_data(GTK_OBJECT(dialog), "clist2");
   flim_plugin_update_lists(l1, l2);
   gtk_widget_show(dialog);
   menuitem = NULL;
   user_data = NULL;
}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   GtkWidget *dialog;
   
   dialog = create_about();
   gtk_widget_show(dialog);
   menuitem = NULL;
   user_data = NULL;
}


void
on_nodes_tree_select_row               (GtkCTree        *ctree,
                                        GList           *node,
                                        gint             column,
                                        gpointer         user_data)
{
   int *data;
   Msg msg;

   data = gtk_ctree_node_get_row_data(ctree, (GtkCTreeNode *)node);
   if (!data)
      return;
   if (*data == 0) /* nexxus */
     {
	Nexxus *nx;
	GList *l;
	
	nx = (Nexxus *)data;
	nx->selected = 1;
	g_snprintf(msg.msg, sizeof(msg.msg), "nexxus_select");
	g_snprintf(msg.dat, sizeof(msg.dat), "%s", nx->name);
	flim_plugin_broadcast(&msg);
	for (l = nx->nodes; l; l = l->next)
	  {
	     Node *nd;
	     GtkCTreeNode *ctree_node;
	     
	     nd = l->data;
	     ctree_node = gtk_ctree_find_by_row_data(ctree, NULL, nd);
	     if (ctree_node)
		gtk_ctree_select(ctree, ctree_node);
	  }
     }
   else if (*data == 1) /* node */
     {
	Node *nd;
	
	nd = (Node *)data;
	nd->selected = 1;
	g_snprintf(msg.msg, sizeof(msg.msg), "node_select");
	g_snprintf(msg.dat, sizeof(msg.dat), "%s:%s", nd->nexxus->name, nd->name);
	flim_plugin_broadcast(&msg);
     }
   ctree = NULL;
   node = NULL;
   column = 0;
   user_data = NULL;
}


void
on_nodes_tree_unselect_row             (GtkCTree        *ctree,
                                        GList           *node,
                                        gint             column,
                                        gpointer         user_data)
{
   int *data;
   Msg msg;

   data = gtk_ctree_node_get_row_data(ctree, (GtkCTreeNode *)node);
   if (!data)
      return;
   if (*data == 0) /* nexxus */
     {
	Nexxus *nx;
	GList *l;
	
	nx = (Nexxus *)data;
	nx->selected = 0;
	g_snprintf(msg.msg, sizeof(msg.msg), "nexxus_unselect");
	g_snprintf(msg.dat, sizeof(msg.dat), "%s", nx->name);
	flim_plugin_broadcast(&msg);
	for (l = nx->nodes; l; l = l->next)
	  {
	     Node *nd;
	     GtkCTreeNode *ctree_node;
	     
	     nd = l->data;
	     ctree_node = gtk_ctree_find_by_row_data(ctree, NULL, nd);
	     if (ctree_node)
		gtk_ctree_unselect(ctree, ctree_node);
	  }
     }
   else if (*data == 1) /* node */
     {
	Node *nd;
	
	nd = (Node *)data;
	nd->selected = 0;
	g_snprintf(msg.msg, sizeof(msg.msg), "node_unselect");
	g_snprintf(msg.dat, sizeof(msg.dat), "%s:%s", nd->nexxus->name, nd->name);
	flim_plugin_broadcast(&msg);
     }
   ctree = NULL;
   node = NULL;
   column = 0;
   user_data = NULL;
}


void
on_clist1_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
   Group *g;
   
   g = gtk_clist_get_row_data(clist, row);
   if (g)
     {
	g->selected = 1;
     }
   flim_group_select(node_tree);
   clist = NULL;
   row = 0;
   column = 0;
   event = NULL;
   user_data = NULL;
}

void
on_clist1_unselect_row                   (GtkCList        *clist,
					  gint             row,
					  gint             column,
					  GdkEvent        *event,
					  gpointer         user_data)
{
   Group *g;
   
   g = gtk_clist_get_row_data(clist, row);
   if (g)
     {
	g->selected = 0;
     }   
   flim_group_select(node_tree);
   clist = NULL;
   row = 0;
   column = 0;
   event = NULL;
   user_data = NULL;
}


void
on_clist1_unselect_all                 (GtkCList        *clist,
                                        gpointer         user_data)
{
   clist = NULL;
   user_data = NULL;
}


gboolean
on_about_delete_event                  (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
   gtk_widget_destroy(widget);   
   return FALSE;
   widget = NULL;
   event = NULL;
   user_data = NULL;
}


void
on_about_button_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *top;
   
   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   gtk_widget_destroy(top);   
   button = NULL;
   user_data = NULL;
}


gboolean
on_prefs_delete_event                  (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
   gtk_widget_destroy(widget);
   return FALSE;
   widget = NULL;
   event = NULL;
   user_data = NULL;
}


gboolean
on_nexxus_settings_delete_event        (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
   gtk_widget_destroy(widget);
   return FALSE;
   widget = NULL;
   event = NULL;
   user_data = NULL;
}

void
on_add_toolbar_clicked               (GtkButton       *button,
				      gpointer         user_data)
{
   GtkWidget *top, *sel;
   
   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   sel = create_fileselection1();
   gtk_file_selection_set_filename(GTK_FILE_SELECTION(sel), LIBDIR"/flim/");
   gtk_object_set_data(GTK_OBJECT(sel), "add_to_toolbar", (void *)1);
   gtk_object_set_data(GTK_OBJECT(sel), "prefs", top);
   gtk_widget_show(sel);
   button = NULL;
   user_data = NULL;
}


void
on_del_toolbar_clicked               (GtkButton       *button,
				      gpointer         user_data)
{
   GtkWidget *top;
   
   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   message(_("You can't delete plugins from the list yet\n"
	   "just deactivate the plugin instead for now\n"));
   button = NULL;
   user_data = NULL;
}


void
on_button5_clicked               (GtkButton       *button,
				  gpointer         user_data)
{
   GtkWidget *top, *sel;
   
   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   sel = create_fileselection1();
   gtk_file_selection_set_filename(GTK_FILE_SELECTION(sel), LIBDIR"/flim/");
   gtk_object_set_data(GTK_OBJECT(sel), "add_to_normal", (void *)1);
   gtk_object_set_data(GTK_OBJECT(sel), "prefs", top);
   gtk_widget_show(sel);
   button = NULL;
   user_data = NULL;
}


void
on_button6_clicked               (GtkButton       *button,
				  gpointer         user_data)
{
   GtkWidget *top;
   
   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   message(_("You can't delete plugins from the list yet\n"
	   "just deactivate the plugin instead for now\n"));
   button = NULL;
   user_data = NULL;
}

void
on_tp_select_row                   (GtkCList        *clist,
				    gint             row,
				    gint             column,
				    GdkEvent        *event,
				    gpointer         user_data)
{
   /* start the plugin */
   GList *l;
   
   l = g_list_nth(installed_toolbar_plugins, row);
   if (l)
     {
	Installed_Plugin *i_plugin;
	
	i_plugin = l->data;
	if (!i_plugin->active)
	   flim_plugin_start(i_plugin->path);
	i_plugin->active = 1;
     }
   clist = NULL;
   row = 0;
   column = 0;
   event = NULL;
   user_data = NULL;
}

void
on_tp_unselect_row                   (GtkCList        *clist,
				      gint             row,
				      gint             column,
				      GdkEvent        *event,
				      gpointer         user_data)
{
   /* stop the plugin */
   GList *l;
   
   l = g_list_nth(installed_toolbar_plugins, row);
   if (l)
     {
	Installed_Plugin *i_plugin;
	
	i_plugin = l->data;
	if (i_plugin->active)
	   flim_plugin_stop(flim_plugin_find(i_plugin->path));
	i_plugin->active = 0;
     }
   clist = NULL;
   row = 0;
   column = 0;
   event = NULL;
   user_data = NULL;
}

void
on_p_select_row                   (GtkCList        *clist,
				    gint             row,
				    gint             column,
				    GdkEvent        *event,
				    gpointer         user_data)
{
   /* start the plugin */
   GList *l;
   
   l = g_list_nth(installed_plugins, row);
   if (l)
     {
	Installed_Plugin *i_plugin;
	
	i_plugin = l->data;
	if (!i_plugin->active)
	   flim_plugin_start(i_plugin->path);
	i_plugin->active = 1;
     }
   clist = NULL;
   row = 0;
   column = 0;
   event = NULL;
   user_data = NULL;
}


void
on_p_unselect_row                   (GtkCList        *clist,
				      gint             row,
				      gint             column,
				      GdkEvent        *event,
				      gpointer         user_data)
{
   /* stop the plugin */
   GList *l;
   
   l = g_list_nth(installed_plugins, row);
   if (l)
     {
	Installed_Plugin *i_plugin;
	
	i_plugin = l->data;
	if (i_plugin->active)
	   flim_plugin_stop(flim_plugin_find(i_plugin->path));
	i_plugin->active = 0;
     }
   clist = NULL;
   row = 0;
   column = 0;
   event = NULL;
   user_data = NULL;
}

void
on_file_ok_button1_clicked             (GtkButton       *button,
					gpointer         user_data)
{
   GtkWidget *top, *l1, *l2;
   char *file;
   
   
   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   file = gtk_file_selection_get_filename(GTK_FILE_SELECTION(top));
   if ((strlen(file) < 4) ||
       ((file[strlen(file) - 1] != 'p') || (file[strlen(file) - 2] != '.')))
     {
	message(_("That is not a flim plugin\n"
		"please chose a real plugin.\n"
		"\n"
		"(Flim plugins end in .p)"));
	return;
     }
   if (gtk_object_get_data(GTK_OBJECT(top), "add_to_toolbar"))
     {
	flim_toolbar_plugin_add(file);
     }
   else
     {
	flim_plugin_add(file);
     }
   l1 = gtk_object_get_data(GTK_OBJECT(gtk_object_get_data(GTK_OBJECT(top), "prefs")), "clist1");
   l2 = gtk_object_get_data(GTK_OBJECT(gtk_object_get_data(GTK_OBJECT(top), "prefs")), "clist2");
   flim_plugin_update_lists(l1, l2);
   gtk_widget_destroy(top);
   button = NULL;
   user_data = NULL;
}


void
on_file_cancel_button1_clicked         (GtkButton       *button,
					gpointer         user_data)
{
   GtkWidget *top;
   
   top = gtk_widget_get_toplevel(GTK_WIDGET(button));   
   gtk_widget_destroy(top);
   button = NULL;
   user_data = NULL;
}


void
on_prefernces_ok_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *top;
   
   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   gtk_widget_destroy(top);
   button = NULL;
   user_data = NULL;
}


void
on_prefercnes_close_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *top;
   
   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   gtk_widget_destroy(top);
   button = NULL;
   user_data = NULL;
}

void
on_msg_ok_clicked            (GtkButton       *button,
			      gpointer         user_data)
{
   GtkWidget *top;
   
   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   gtk_widget_destroy(top);
   button = NULL;
   user_data = NULL;
}


void
on_nexxus_ok_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *top, *w;
   Nexxus *nx, *new_nx;
   char *prev_address, *prev_name;
   Msg msg;
   char *name, *address, *login, *password;
   
   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   new_nx = gtk_object_get_data(GTK_OBJECT(top), "__new");
   nx = gtk_object_get_data(GTK_OBJECT(top), "__nexxus");
   w = gtk_object_get_data(GTK_OBJECT(top), "entry1");
   prev_name = nx->name;
   nx->name = g_strdup(gtk_entry_get_text(GTK_ENTRY(w)));
   g_snprintf(msg.msg, sizeof(msg.msg), "nexxus_rename");
   g_snprintf(msg.dat, sizeof(msg.dat), "%s:%s", prev_name, nx->name);
   if (prev_name) g_free(prev_name);
   flim_plugin_broadcast(&msg);
   w = gtk_object_get_data(GTK_OBJECT(top), "entry2");
   prev_address = nx->address;
   nx->address = g_strdup(gtk_entry_get_text(GTK_ENTRY(w)));
   w = gtk_object_get_data(GTK_OBJECT(top), "entry3");
   nx->login = g_strdup(gtk_entry_get_text(GTK_ENTRY(w)));
   w = gtk_object_get_data(GTK_OBJECT(top), "entry4");
   nx->password = g_strdup(gtk_entry_get_text(GTK_ENTRY(w)));
#if 0   
   if (prev_address)
     {
	if (strcmp(prev_address, nx->address))
	  {
#endif	     
	     flim_nexxus_disconnect(nx);
	     name = nx->name;
	     address = nx->address;
	     login = nx->login;
	     password = nx->password;
	     if (!name) name = "";
	     if (!address) address = "";
	     if (!login) login = "";
	     if (!password) password = "";
	     g_snprintf(msg.msg, sizeof(msg.msg), "nexxus_address");
	     g_snprintf(msg.dat, sizeof(msg.dat), "%s:%s:%s:%s", nx->name, nx->address, nx->login, nx->password);
	     flim_plugin_broadcast(&msg);
	     flim_nexxus_connect(nx);
#if 0	     
	  }
     }
#endif   
   if (prev_address)
      g_free(prev_address);
   flim_nexxus_build_tree(node_tree);
   gtk_widget_destroy(top);
   button = NULL;
   user_data = NULL;
}


gboolean
on_node_settings_delete_event          (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
   gtk_widget_destroy(widget);
   return FALSE;
   widget = NULL;
   event = NULL;
   user_data = NULL;
}


void
on_node_ok_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *top, *w, *type;
   Nexxus *nx;
   Node *nd;
   char buf[4096], *new_name, *new_address, *new_device, *new_password, *new_asset_tag, *nt;
   Msg msg;
   int error = 0;
   int guess_emp;
   
   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   nx = gtk_object_get_data(GTK_OBJECT(top), "__nexxus");
   nd = gtk_object_get_data(GTK_OBJECT(top), "__node");
   w = gtk_object_get_data(GTK_OBJECT(top), "entry4");
   type = gtk_object_get_data(GTK_OBJECT(top), "node_type");
   nt = gtk_entry_get_text(GTK_ENTRY(type));
   new_name = gtk_entry_get_text(GTK_ENTRY(w));
   if (new_name) 
      {
	 new_name = g_strdup(new_name);
	 if (strlen(new_name) < 1)
	   {
	      g_free(new_name);
	      message(_("You cannot have a Node with no name"));
	      return;
	   }
      }
   w = gtk_object_get_data(GTK_OBJECT(top), "entry5");
   new_address = gtk_entry_get_text(GTK_ENTRY(w));
   if (new_address) new_address = g_strdup(new_address);
   w = gtk_object_get_data(GTK_OBJECT(top), "entry6");

   new_device = gtk_entry_get_text(GTK_ENTRY(w));
   if (new_device) 
     {
	new_device = g_strdup(new_device);
	if (strlen(new_device) < 1) {g_free(new_device); new_device = NULL;}
     }
   w = gtk_object_get_data(GTK_OBJECT(top), "entry7");
   new_password = gtk_entry_get_text(GTK_ENTRY(w));
   if (new_password) 
     {
	new_password =  g_strdup(new_password);
	if (strlen(new_password) < 1) {g_free(new_password); new_password = NULL;}
     }
   w = gtk_object_get_data(GTK_OBJECT(top), "entry8");
   new_asset_tag = gtk_entry_get_text(GTK_ENTRY(w));
   if (new_asset_tag) 
      {
	 new_asset_tag = g_strdup(new_asset_tag);
	if (strlen(new_asset_tag) < 1) {g_free(new_asset_tag); new_asset_tag = NULL;}
      }

   if (new_name)
     {
	if ((!nd->name) || strcmp(new_name, nd->name))
	  {
	     g_snprintf(buf, sizeof(buf), "NEXXUS:NODE_RENAME:%s:%s",
			nd->name, new_name);
	     FLIM_COMMS_BEGIN(nx->connection, buf);
	     if ((!strcmp(FLIM_COMMS_REPLY[2], "JOB_ERROR")) &&
		 (!strcmp(FLIM_COMMS_REPLY[3], "NODE_EXISTS")))
	       {
		  message(_("You cannot name your Node by that\n"
			  "name as a node in that Nexxus already\n"
			  "has that name."));
		  error = 1;
	       }
	     FILM_COMMS_REPLY_END;
	     if (error) return;
	     g_snprintf(msg.msg, sizeof(msg.msg), "node_rename");
	     g_snprintf(msg.dat, sizeof(msg.dat), "%s:%s:%s", nx->name, nd->name, new_name);
	     flim_plugin_broadcast(&msg);
	  }
     }
   if (nd->name) g_free(nd->name);
   nd->name = new_name;
   if (!strcmp(nt, "EMP"))
     {
	char *nd_dev, *nd_pass;
	
	nd_dev = new_device;
	nd_pass = new_password;
	if (!nd_dev) nd_dev = "";
	if (!nd_pass) nd_pass = "NONE";
	g_snprintf(buf, sizeof(buf), "EMP:CONFIGURATION:%s:%s:%s",
	      nd->name, nd_dev, nd_pass);
	FLIM_COMMS_BEGIN(nx->connection, buf);
	if (!strcmp(FLIM_COMMS_REPLY[2], "JOB_ERROR"))
	  {
	     error = 2;
	     if (!strcmp(FLIM_COMMS_REPLY[3], "PORT_IN_USE"))
	       {
		  message(_("You cannot use that device for the\n"
			    "Node as it is already in use."));
		  error = 1;
	       }       
	  }
	if ((!strcmp(FLIM_COMMS_REPLY[2], "STAUS")) &&
	    (!strcmp(FLIM_COMMS_REPLY[2], "ENGAGING")))
	  {
	     error = 2;
	  }
	FILM_COMMS_REPLY_END;
     }
   else if (!strcmp(nt, "VA1000"))
     {
	char *nd_dev;
	
	nd_dev = new_device;
	if (!nd_dev) nd_dev = "";
	g_snprintf(buf, sizeof(buf), "va1000:CONFIGURATION:%s:%s",
	      nd->name, nd_dev);
	FLIM_COMMS_BEGIN(nx->connection, buf);
	error = 0;
	if ((!strcmp(FLIM_COMMS_REPLY[2], "JOB_ERROR")) &&
	    (!strcmp(FLIM_COMMS_REPLY[3], "PORT_IN_USE")))
	  {
	     message(_("You cannot use that device for the\n"
		     "Node as it is already in use."));
	     error = 2;
	  }
	if ((!strcmp(FLIM_COMMS_REPLY[2], "JOB_ERROR")))
	  error = 2;
	FILM_COMMS_REPLY_END;
     }
   else if (!strcmp(nt, "VASENET"))
     {
	char *nd_dev, *cp;
	char d1[4096], d2[4096];
	
	nd_dev = new_device;
	if (!nd_dev) nd_dev = "";
	cp = strchr(nd_dev, '/');
	/* to add avsenet device: */
	/* <master_node_name>/<vasent_address> */
	if (cp)
	  {
	     strncpy(d1, nd_dev, (cp - nd_dev));
	     d1[cp - nd_dev] = 0;
	     strcpy(d2, &(cp[1]));
	     g_snprintf(buf, sizeof(buf), "vasenet:CONFIGURATION:%s:SLAVE:%s:%s",
			nd->name, d1, d2);
	     FLIM_COMMS_BEGIN(nx->connection, buf);
	     error = 0;
	     if ((!strcmp(FLIM_COMMS_REPLY[2], "JOB_ERROR")) &&
		 (!strcmp(FLIM_COMMS_REPLY[3], "PORT_IN_USE")))
	       {
		  message(_("You cannot use that device for the\n"
				   "Node as it is already in use."));
		  error = 1;
	       }
	     if ((!strcmp(FLIM_COMMS_REPLY[2], "JOB_ERROR")))
	       error = 1;
	     else
	       {
	       }
	     FILM_COMMS_REPLY_END;	
	  }
	/* to add a v100 box device woudl be: */
	/* va100:<password> */
	if (!strstr(nd_dev, "va100:"))
	  {
	     cp = strchr(nd_dev, ':');
	     strncpy(d1, nd_dev, (cp - nd_dev));
	     d1[cp - nd_dev] = 0;
	     strcpy(d2, &(cp[1]));
	     g_snprintf(buf, sizeof(buf), "vasenet:CONFIGURATION:%s:MASTER:%s",
			nd->name, d2);
	     FLIM_COMMS_BEGIN(nx->connection, buf);
	     error = 0;
	     if ((!strcmp(FLIM_COMMS_REPLY[2], "JOB_ERROR")) &&
		 (!strcmp(FLIM_COMMS_REPLY[3], "PORT_IN_USE")))
	       {
		  message(_("You cannot use that device for the\n"
				   "Node as it is already in use."));
		  error = 1;
	       }
	     if ((!strcmp(FLIM_COMMS_REPLY[2], "JOB_ERROR")))
	       error = 2;
	     else
	       {
	       }
	     FILM_COMMS_REPLY_END;
	  }
     }
   else if (!strcmp(nt, "QUANTA"))
     {
        char *nd_dev;
	
	nd_dev = new_device;
	if (!nd_dev) nd_dev = "";
	error = 0;
        g_snprintf(buf, sizeof(buf), "QUANTA:CONFIGURATION:%s:%s",
		   nd->name, nd_dev);
	FLIM_COMMS_BEGIN(nx->connection, buf);
	if (!strcmp(FLIM_COMMS_REPLY[2], "JOB_ERROR"))
	  {
	     error = 2;
	     if (!strcmp(FLIM_COMMS_REPLY[3], "PORT_IN_USE"))
	       {
		  message(_("You cannot use that device for the\n"
			    "Node as it is already in use."));
		  error = 1;
	       }       
	  }
	FILM_COMMS_REPLY_END;	
     }
   else if (!strcmp(nt, "SBT2"))
     {
        char *nd_dev;
	
	nd_dev = new_device;
	if (!nd_dev) nd_dev = "";
	error = 0;
        g_snprintf(buf, sizeof(buf), "SBT2:CONFIGURATION:%s:%s",
		   nd->name, nd_dev);
	FLIM_COMMS_BEGIN(nx->connection, buf);
	if (!strcmp(FLIM_COMMS_REPLY[2], "JOB_ERROR"))
	  {
	     error = 2;
	     if (!strcmp(FLIM_COMMS_REPLY[3], "PORT_IN_USE"))
	       {
		  message(_("You cannot use that device for the\n"
			    "Node as it is already in use."));
		  error = 1;
	       }       
	  }
	FILM_COMMS_REPLY_END;	
     }
   if (error)
      return;
   if (nd->password) g_free(nd->password);
   nd->password = new_password;
   if (nd->device) g_free(nd->device);
   nd->device = new_device;

   if (new_address)
     {
	if (strlen(new_address) > 1)
	  {
	     g_snprintf(buf, sizeof(buf), "NEXXUS:SET_VAR:%s:IP_ADDRESS:%s",
			nd->name, new_address);
	     FLIM_COMMS_BEGIN(nx->connection, buf);
	     if (!strcmp(FLIM_COMMS_REPLY[2], "JOB_ERROR"))
	       {
		  g_snprintf(buf, sizeof(buf), 
			     _("There was an error setting the\n"
			     "IP Address of the Node:\n"
			     "\n"
			     "%s\n"), FLIM_COMMS_REPLY[3]);
		  message(buf);
	       }
	     FILM_COMMS_REPLY_END;
	  }
     }
   if (nd->address) g_free(nd->address);
   nd->address = new_address;

   if (new_asset_tag)
     {
	if (strlen(new_asset_tag) > 11)
	  {
	     message(_("Your asset tag is too long\n"
		     "There is a limit of 11 characters."));
	     flim_nexxus_build_tree(node_tree);
	     if (new_asset_tag) g_free(new_asset_tag);
	     return;
	  }
	else if (strlen(new_asset_tag) > 1)
	  {
	     g_snprintf(buf, sizeof(buf), "EMP:SET_ASSET_TAG:%s:%s",
			nd->name, new_asset_tag);
	     FLIM_COMMS_BEGIN(nx->connection, buf);
	     if (!strcmp(FLIM_COMMS_REPLY[2], "JOB_ERROR"))
	       {
		  g_snprintf(buf, sizeof(buf), 
			     _("There was an error setting the\n"
			     "Asset Tag of the Node:\n"
			     "\n"
			     "%s\n"), FLIM_COMMS_REPLY[3]);
		  message(buf);
	       }
	     FILM_COMMS_REPLY_END;
	  }
     }
   if (nd->asset_tag) g_free(nd->asset_tag);
   nd->asset_tag = new_asset_tag;
   
   flim_nexxus_build_tree(node_tree);
   gtk_widget_destroy(top);
   button = NULL;
   user_data = NULL;
}


gboolean
on_group_settings_delete_event         (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
   gtk_widget_destroy(widget);
   return FALSE;
   widget = NULL;
   event = NULL;
   user_data = NULL;
}


void
on_group_ok_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
   GtkWidget *top, *w;
   Group *g;
   
   top = gtk_widget_get_toplevel(GTK_WIDGET(button));
   g = gtk_object_get_data(GTK_OBJECT(top), "__group");
   w = gtk_object_get_data(GTK_OBJECT(top), "entry9");
   if (flim_group_find(gtk_entry_get_text(GTK_ENTRY(w))))
     {
	message(_("You cannot name the group to that name\n"
		"because a group of that name already\n"
		"exists in your group list."));
	return;
     }
   if (g->name)
      g_free(g->name);
   g->name = g_strdup(gtk_entry_get_text(GTK_ENTRY(w)));
   flim_group_build_list(group_list);
   gtk_widget_destroy(top);   
   button = NULL;
   user_data = NULL;
}

