#include "main.h"

Node *
flim_node_new(void)
{
   Node *nd;
   
   nd = g_malloc(sizeof(Node));
   nd->type = 1;
   nd->name = NULL;
   nd->address = NULL;
   nd->device = NULL;
   nd->password = NULL;
   nd->asset_tag = NULL;
   
   nd->id = NULL;
   nd->state = 0;

   nd->nexxus = NULL;
   nd->selected = 0;
   return nd;
}

Node *
flim_node_find(char *name, Nexxus *nx)
{
   GList *l;
   
   for (l = nx->nodes; l; l = l->next)
     {
	Node *nd;
	
	nd = l->data;
	if (!strcmp(nd->name, name))
	   return nd;
     }
   return NULL;
}

void
flim_node_free(Node *nd)
{
   if (nd->name) g_free(nd->name);
   if (nd->address) g_free(nd->address);
   if (nd->device) g_free(nd->device);
   if (nd->password) g_free(nd->password);
   if (nd->asset_tag) g_free(nd->asset_tag);
   if (nd->id) g_free(nd->id);
   g_free(nd);
}

void
flim_node_get_info(Nexxus *nx, Node *nd)
{
   char buf[4096];

   g_snprintf(buf, sizeof(buf), "emp:inquiry:%s", nd->name);
   FLIM_COMMS_BEGIN(nx->connection, buf);
   if ((FLIM_COMMS_REPLY) && (FLIM_COMMS_REPLY_COUNT != -1))
     {
	while (FLIM_COMMS_REPLY)
	  {
	     if (FLIM_COMMS_REPLY_COUNT < 3)
		break;
	     if (!strcmp("MODULE_NOT_FOUND", FLIM_COMMS_REPLY[2]))
		break;
	     if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2]))
		break;
	     if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2]))
	       {
		  nd->state = 1;
		  break;
	       }
	     if (!strcmp(FLIM_COMMS_REPLY[2], "INQUIRY"))
	       {
		  if (FLIM_COMMS_REPLY[4])
		    {
		       if (nd->id) g_free(nd->id);
		       nd->id     = g_strdup(FLIM_COMMS_REPLY[4]);
		    }
		  if (FLIM_COMMS_REPLY[5])
		    {
		       if (nd->device) g_free(nd->device);
		       nd->device = g_strdup(FLIM_COMMS_REPLY[5]);
		    }
		  if (!strcmp(FLIM_COMMS_REPLY[6], "WAITING")) /* waiting for proto */
		    {
		       nd->state = 0;
		    }
		  else if (!strcmp(FLIM_COMMS_REPLY[6], "INITIALIZING")) /* init stage */
		    {
		       nd->state = 0;
		    }
		  else if (!strcmp(FLIM_COMMS_REPLY[6], "NEGOTIATING")) /* init stage */
		    {
		       nd->state = 0;
		    }
		  else if (!strcmp(FLIM_COMMS_REPLY[6], "DETECTED")) /* all ok */
		    {
		       nd->state = 1;
		    }
		  else if (!strcmp(FLIM_COMMS_REPLY[6], "NOT_DETECTED")) /* no proto */
		    {
		       nd->state = -1;
		    }
		  else if (!strcmp(FLIM_COMMS_REPLY[6], "DEAD")) /* dead */
		    {
		       nd->state = -1;
		    }
		  else if (!strcmp(FLIM_COMMS_REPLY[6], "RUNNING")) /* all ok */
		    {
		       nd->state = 1;
		    }
		  if (FLIM_COMMS_REPLY[7])
		    {
		       if (nd->password) g_free(nd->password);
		       nd->password = g_strdup(FLIM_COMMS_REPLY[7]);
		    }
	       }
	     FILM_COMMS_GET_REPLY;
	  }
     }
   FILM_COMMS_REPLY_END;
#if 1
   if (!nd->device)
     {
	g_snprintf(buf, sizeof(buf), "va1000:inquiry:%s", nd->name);
	FLIM_COMMS_BEGIN(nx->connection, buf);
	if ((FLIM_COMMS_REPLY) && (FLIM_COMMS_REPLY_COUNT != -1))
	  {
	     while (FLIM_COMMS_REPLY)
	       {
		  if (FLIM_COMMS_REPLY_COUNT < 3)
		     break;
		  if (!strcmp("MODULE_NOT_FOUND", FLIM_COMMS_REPLY[2]))
		     break;
		  if (!strcmp("MODULE_ERROR", FLIM_COMMS_REPLY[2]))
		     break;
		  if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2]))
		     break;
		  if (!strcmp(FLIM_COMMS_REPLY[2], "INQUIRY"))
		    {
		       
		       if (FLIM_COMMS_REPLY[4])
			 {
			    if (nd->device) g_free(nd->device);
			    nd->device = g_strdup(FLIM_COMMS_REPLY[4]);
			 }
		    }
		  FILM_COMMS_GET_REPLY;
	       }
	  }
	FILM_COMMS_REPLY_END;
     }
#endif
#if 1
   if (!nd->device)
     {
	g_snprintf(buf, sizeof(buf), "vasenet:inquiry:%s", nd->name);
	FLIM_COMMS_BEGIN(nx->connection, buf);
	if ((FLIM_COMMS_REPLY) && (FLIM_COMMS_REPLY_COUNT != -1))
	  {
	     while (FLIM_COMMS_REPLY)
	       {
		  if (FLIM_COMMS_REPLY_COUNT < 3)
		     break;
		  if (!strcmp("MODULE_NOT_FOUND", FLIM_COMMS_REPLY[2]))
		     break;
		  if (!strcmp("MODULE_ERROR", FLIM_COMMS_REPLY[2]))
		     break;
		  if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2]))
		     break;
		  if (FLIM_COMMS_REPLY_COUNT < 6)
		     break;
		  if (!strcmp(FLIM_COMMS_REPLY[2], "INQUIRY"))
		    {
		       if ((FLIM_COMMS_REPLY[4]) && (FLIM_COMMS_REPLY[5]))
			 {
			    char buf[4096];
			    
			    if (nd->device) g_free(nd->device);
			    sprintf(buf, "%s/%s", 
				    FLIM_COMMS_REPLY[4], 
				    FLIM_COMMS_REPLY[5]);
			    nd->device = g_strdup(buf);
			 }
		    }
		  FILM_COMMS_GET_REPLY;
	       }
	  }
	FILM_COMMS_REPLY_END;
     }
#endif
#if 1
   if (!nd->device)
     {
	g_snprintf(buf, sizeof(buf), "sbt2:inquiry:%s", nd->name);
	FLIM_COMMS_BEGIN(nx->connection, buf);
	if ((FLIM_COMMS_REPLY) && (FLIM_COMMS_REPLY_COUNT != -1))
	  {
	     while (FLIM_COMMS_REPLY)
	       {
		  if (FLIM_COMMS_REPLY_COUNT < 3)
		     break;
		  if (!strcmp("MODULE_NOT_FOUND", FLIM_COMMS_REPLY[2]))
		     break;
		  if (!strcmp("MODULE_ERROR", FLIM_COMMS_REPLY[2]))
		     break;
		  if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2]))
		     break;
		  if (FLIM_COMMS_REPLY_COUNT < 5)
		     break;
		  if (!strcmp(FLIM_COMMS_REPLY[2], "INQUIRY"))
		    {
		       if (FLIM_COMMS_REPLY[4])
			 {
			    char buf[4096];
			    
			    if (nd->device) g_free(nd->device);
			    nd->device = g_strdup(FLIM_COMMS_REPLY[4]);
			 }
		    }
		  FILM_COMMS_GET_REPLY;
	       }
	  }
	FILM_COMMS_REPLY_END;
     }
#endif
#if 1
   if (!nd->device)
     {
	g_snprintf(buf, sizeof(buf), "quanta:inquiry:%s", nd->name);
	FLIM_COMMS_BEGIN(nx->connection, buf);
	if ((FLIM_COMMS_REPLY) && (FLIM_COMMS_REPLY_COUNT != -1))
	  {
	     while (FLIM_COMMS_REPLY)
	       {
		  if (FLIM_COMMS_REPLY_COUNT < 3)
		     break;
		  if (!strcmp("MODULE_NOT_FOUND", FLIM_COMMS_REPLY[2]))
		     break;
		  if (!strcmp("MODULE_ERROR", FLIM_COMMS_REPLY[2]))
		     break;
		  if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2]))
		     break;
		  if (FLIM_COMMS_REPLY_COUNT < 5)
		     break;
		  if (!strcmp(FLIM_COMMS_REPLY[2], "INQUIRY"))
		    {
		       if (FLIM_COMMS_REPLY[4])
			 {
			    char buf[4096];
			    
			    if (nd->device) g_free(nd->device);
			    nd->device = g_strdup(FLIM_COMMS_REPLY[4]);
			 }
		    }
		  FILM_COMMS_GET_REPLY;
	       }
	  }
	FILM_COMMS_REPLY_END;
     }
#endif
   g_snprintf(buf, sizeof(buf), "NEXXUS:GET_VAR:%s:IP_ADDRESS", nd->name);
   FLIM_COMMS_BEGIN(nx->connection, buf);
   while (FLIM_COMMS_REPLY)
     {
	if (FLIM_COMMS_REPLY_COUNT < 4)
	   break;
	if (!strcmp("JOB_COMPLETED", FLIM_COMMS_REPLY[2]))
	   break;
	if (!strcmp("MODULE_NOT_FOUND", FLIM_COMMS_REPLY[2]))
	   break;
	if (!strcmp("JOB_ERROR", FLIM_COMMS_REPLY[2]))
	   break;
	if (FLIM_COMMS_REPLY[3])
	  {
	     if (nd->address) g_free(nd->address);
	     nd->address = g_strdup(FLIM_COMMS_REPLY[3]);
	  }
	FILM_COMMS_GET_REPLY;
     }
   FILM_COMMS_REPLY_END;
}

