#ifndef _PROTOTYPES_H
#define _PROTOTYPES_H

#include <emp_slave_context.h>
#include <emp_module_harness.h>
#include <config.h>

/* emp_module_harness.c */

void node_destroy(NODELIST *node);

/* emp_slave_machine.c */
void slave_machine_start(int, int);

/* emp_slave_context.c */
int context_variable_set(char *, char *, char *);
int context_rename(char *, char *);
int context_send_ipc(char *, char *);
int context_destroy(char *);
CONTEXT *context_create(char *);;
CONTEXT *context_lookup(char *);
void context_destroy_all(void);
void context_init(void);
void context_notify_disconnection_all(int fd);

/* emp_slave.c */
int slave_assign_and_notify(NODELIST *);
int slave_remove_node(NODELIST *);
SLAVE *locate_available_slave(void);
int slave_notify_variable(NODELIST *, char *, char *);
int slave_notify_rename_node(NODELIST *, char *);
int slave_notify_del_node(NODELIST *);
int slave_notify_new_node(NODELIST *);
void slave_destroy(SLAVE *);
int slave_send(SLAVE *, char *);
int slave_deinit(void);
int slave_notify_disconnection(int client_fd);

/* emp_thread.c */
void *thread_start(void *);

/* emp_driver.c */
void *driver_thread_start(void *);

/* emp_sensor.c */
void *sensor_thread_start(void *);

/* emp_thread_common.c */
int unnormalize_data(unsigned char *src, unsigned char *dst,int I_srclen);
int normalize_data(unsigned char *src, unsigned char *dst);
char *return_ccstr(unsigned char cc);
int send_msg(CONTEXT *ctx, int fd, char *msg);
int lookup_sensor_number(SENSOR *sensor);
int recv_msg(int fd, char **buffer, __uint32_t *len);

#endif
