/*
 * This program is original work by San Mehat <nettwerk@valinux.com> and
 * Zac Sprackett <zac@sprackett.com>.
 * This program is distributed under the GNU Lesser General Public License
 * (LGPL).
 *
 * Copyright (C) 1999, San Mehat, Zac Sprackett and VA Linux Systems
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */
#ifndef _LIBLOOSE_PRIVATE_H
#define _LIBLOOSE_PRIVATE_H

typedef struct lm_timer
	{
	int						tag;

	unsigned int	freq;
	unsigned int	alarm_time;
	int						(*cb) (void *);
	void					*arg;
	} LM_TIMER;

typedef struct lm_fd_watcher
	{
	int		I_fd;
	void	(*cb) (int, void *);
	void	*arg;
	} LM_FD_WATCHER;

void destroy_fd_watcher(void *data);
void destroy_timer(void *data);
int create_timer_tag(void);

#endif 
