/*
 * This program is original work by San Mehat <nettwerk@valinux.com> .
 * This program is distributed under the GNU General Public License (GPL)
 * as outlined in the COPYING file.
 *
 * Copyright (C) 2000, San Mehat, and VA Linux Systems
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 *  with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */

#ifndef _MSC_SLAVE_CONTEXT_H
#define _MSC_SLAVE_CONTEXT_H

#include <config.h>
#include <pthread.h>

typedef struct slave_context {
	pthread_t	thread;
	pthread_attr_t	attr;

	int	con_sock;
	char	*node_id;
	char	*agent;
	char	*addr;
	
	int	msc_fd;			// pipe to the aux port
	char	device_address[64];
//	char	host[512];
	char	login[16];
	char	password[16];

	int	thread_ipc_read;
	int	thread_ipc_write;
	int	slave_ipc_read;
	int	slave_ipc_write;

	int	refcount;
	struct slave_context	*next;
	struct slave_context	*prev;
} SLAVE_CONTEXT;

#endif
